var nsModuleExport = function(root,name,prototype)
	{
		if(typeof exports === 'object' && typeof module === 'object')
		{
			module.exports[name] = prototype;
		}
		else if (typeof define === "function" && define.amd)
		{
			define(name,[], function () {return prototype;});
		}
		else if(typeof exports === 'object')
		{
			exports[name] = prototype;
		}
		else
		{
			root[name] = prototype;
		}
	};var nsIsWeb = function(root)
	{
		if(typeof exports === 'object' && typeof module === 'object')
		{
			return false;
		}
		else if (typeof define === "function" && define.amd)
		{
			return false;
		}
		else if(typeof exports === 'object')
		{
			return false;
		}
		else
		{
			return true;
		}
	};if(!nsIsWeb())
		{
var nsutilRef = require('./nsUtil.min.js');
var NSUtil = nsutilRef.NSUtil;

		}
var NSZip = (function()
{
	var NSZip = function(config)
	{
		var self = this;
		var setting = {};
	    
	    var objFiles = {};
	    var util = null;
		
		var initialize = function()
		{
			if(!config)
			{
				config = {};
			}
			/*setting = {
				fileName: config["fileName"] || "download",
				mimeType: config["mimeType"] || "application/zip"
			};
			if (setting.fileName.indexOf(".") === -1) 
			{
				setting.fileName = setting.fileName + ".zip";
	        }*/
			util = new ZipUtil();
		};
		
		var getFile = function(type,mimeType)
		{
			var objRet = null;
			type = type ? type : "blob";
			switch(type) 
			{
				case "blob":
					objRet = getBlob(mimeType);
				break;
			}
			return objRet;
		};
		
		var addFolders = function(arrPath)
		{
			var arrReturn = null;
			if(arrPath && arrPath.length > 0)
			{
				arrReturn = [];
				for(var index = 0;index < arrPath.length;index++)
				{
					arrReturn.push(addFolder(arrPath[index]));
				}
			}
			return arrReturn;
		};
		
		var addFolder = function(path)
		{
			return createFolder(path);
		};
		
		var addFile = function(path,content,prop)
		{
			return createFile(path,content,prop,false);
		};
		
		var createFolder = function(path)
		{
			path = util.addSlashAtEnd(path);
			if(objFiles[path])
			{
				return objFiles[path].zipFile;
			}
			return createFile(path,null,null,true);
		};
		
		var createFile = function(path,content,prop,isDir)
		{
			prop = prop ? prop : {};
			var item = {path: path,content: content,origContent: content};
			item.created = new Date();
			item.dataType = util.getDataType(content);
			item.isDir = isDir ? true : false;
			var parent = util.getParentFolder(path);
			if(parent)
			{
				createFolder(parent);
			}
			item.isBase64 = (item.type == "base64");
			item.isBinary = (item.type == "binary");
			var isUnicodeString = (item.dataType === "string") && item.isBase64 && item.isBinary;
			if (item.type != "binary") 
			{
				item.isBinary = !isUnicodeString;
		    }
			if(item.isDir || !path || !path.length)
			{
				item.dataType = "string";
				item.isBase64 = false;
				item.isBinary = true;
				item.content = "";
			}
			item.content = getContent(item);
			var zipFile = new ZipFile(util,item,self);
			objFiles[path] = {item: item,zipFile: zipFile};
			
			return zipFile;
		};
		
		var getContent = function(item)
		{
			var refine = function(data)
			{
				var dataType = item.dataType;
				if(dataType)
				{
					if(dataType === "string")
					{
						if(item.isBase64)
						{
							data = util.base64Decode(data);
						}
						else if(item.isBinary)
						{
							/*var arrData = new Uint8Array(data.length);
							data = util.fillArrayWithString(data,arrData);*/
						}
					}
					else if (dataType === "arraybuffer") 
					{
			            data = new Uint8Array(item);
			        }
				}
				else
				{
					console.warn("DataType cannot be detected for file " + item.path);
				}
				return data;
			};
			var content = item.content;
			var isBlob = (content instanceof Blob || ['[object File]', '[object Blob]'].indexOf(Object.prototype.toString.call(content)) !== -1);
	        if(isBlob && typeof FileReader !== "undefined") 
	        {
	        	return new Promise(function (resolve, reject) 
	        	{
	                var reader = new FileReader();
	                reader.onload = function(event) 
	                {
	                	item.content = refine(event.target.result);
	                	resolve(event.target.result);
	                };
	                reader.onerror = function(event) 
	                {
	                	console.error(event.target.error);
	                    reject(event.target.error);
	                };
	                reader.readAsArrayBuffer(content);
	        	});
	        }
	        return refine(content);
		};
		
		var clear = function()
		{
		     objFiles = {};
		};
		
		var getBlob = function(mimeType)
		{
			mimeType = mimeType ? mimeType : "application/zip";
			var textOutput = buildFileStream();
			var uInt8Output  = util.buildUint8Array(textOutput);
			clear();
			return new Blob([uInt8Output], { type: setting.mimeType });
		};
		
		var buildFileStream = function(initContent)
		{
			initContent = initContent ? initContent : "";
			var len = Object.keys(objFiles).length;
			var middleContent = "";
			var lL = 0;
	        var cL = 0;
	        for(var path in objFiles)
			{
	        	var file = objFiles[path].item;
				var objHeader = getHeader(file, lL);
				var fileHeader = objHeader.fileHeader;
				var folderHeader = objHeader.folderHeader;
				var content = objHeader.content;
				lL += fileHeader.length + content.length;
	            cL += folderHeader.length;
	            initContent +=  fileHeader + content;
	            middleContent += folderHeader;
			}
			var endContent = buildFolderEnd(len, cL, lL);
	        return initContent + middleContent + endContent;
		};
		
		var getHeader = function(file,offset)
		{
			var content = util.utf8_encode(file.content);
			var path = file.path;
			var created = file.created;
			var utfPath = util.utf8_encode(path);
			var isUTF8 = (utfPath !== path);
			var time = util.convertTime(created);
		    var dt = util.convertDate(created);
		    var extraFields = "";
		    if (isUTF8) 
		    {
	            var uExtraFieldPath = util.decToHex(1, 1) + util.decToHex(util.getFromCrc32Table(utfPath), 4) + utfPath;
	            extraFields = "\x75\x70" + util.decToHex(uExtraFieldPath.length, 2) + uExtraFieldPath;
	        }
		    var header = '\x0A\x00' +
	        (isUTF8 ? '\x00\x08' : '\x00\x00') + // general purpose bit flag
	        '\x00\x00' +
	        util.decToHex(time, 2) + // last modified time
	        util.decToHex(dt, 2) + // last modified date
	        util.decToHex(content ? util.getFromCrc32Table(content) : 0, 4) +
	        util.decToHex(content ? content.length : 0, 4) + // compressed size
	        util.decToHex(content ? content.length : 0, 4) + // uncompressed size
	        util.decToHex(utfPath.length, 2) + // file name length
	        util.decToHex(extraFields.length, 2); // extra field length
	        
		    var fileHeader = 'PK\x03\x04' + header + utfPath + extraFields;
	        var folderHeader = 'PK\x01\x02' + // central header
	            '\x14\x00' +
	            header + // file header
	            '\x00\x00' +
	            '\x00\x00' +
	            '\x00\x00' +
	            (content ? '\x00\x00\x00\x00' : '\x10\x00\x00\x00') + // external file attributes
	            util.decToHex(offset, 4) + // relative offset of local header
	            utfPath + // file name
	            extraFields; // extra field
	        return { fileHeader: fileHeader, folderHeader: folderHeader, content: content || '' };
		};
		
		var buildFolderEnd = function(totalEntries,size,startOffset)
		{
			var retValue = "PK\x05\x06" + "\x00\x00" + "\x00\x00";
			retValue += util.decToHex(totalEntries, 2);
			retValue += util.decToHex(totalEntries, 2);
			retValue += util.decToHex(size, 4);
			retValue += util.decToHex(startOffset, 4);
			retValue += "\x00\x00";
			return retValue;
		};
		
	    var downloadFile = function(fileName,mimeType,type,content)
	    {
	    	fileName = fileName ? fileName : "download";
	    	if (fileName.indexOf(".") === -1) 
			{
				fileName = fileName + ".zip";
	        }
	    	content = content ? content : getFile(type,mimeType);
	    	util.downloadFile(fileName,content);
	    };
	    
	    var ZipFile = function(util,item,objRoot)
	    {
	    	var self = this;
	    	
	    	var addFolder = function(path)
	    	{
	    		return objRoot.addFolder(getPath(path));
	    	};
	    	
	    	var addFile = function(path,content)
	    	{
	    		return objRoot.addFile(getPath(path),content);
	    	};
	    	
	    	var getPath = function(path)
	    	{
	    		return item.path + path;
	    	};
	    	
	    	if(item.isDir)
	    	{
	    		self.addFolder = addFolder;
	    		self.addFile = addFile;
	    	}
	    };
	    
	    var ZipUtil = function()
	    {
	    	var self = this;
	    	var crcTable = [];
	    	var base64Key = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	    	
	    	var initialize = function()
	    	{
	    		crcTable = makeCRCTable();
	    	};
	    	
	    	//https://stackoverflow.com/questions/18638900/javascript-crc32
	    	var makeCRCTable = function()
	    	{
	    	    var c;
	    	    var crcTable = [];
	    	    for(var n =0; n < 256; n++)
	    	    {
	    	        c = n;
	    	        for(var k =0; k < 8; k++)
	    	        {
	    	            c = ((c&1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
	    	        }
	    	        crcTable[n] = c;
	    	    }
	    	    return crcTable;
	    	};
	    	
	    	var getFromCrc32Table = function(content, crc)
	        {
	    		if(typeof content === "undefined" || !content.length) 
	    		{
	    	        return 0;
	    	    }
	    		if(!crc)
	        	{
	        		crc = 0;
	        	}
	        	crc ^= (-1);
	    		var dataType = util.getDataType(content);
	    		if(dataType === "string")
	    		{
		            var ch = 0;
		            var k = 0;
		            var l = 0;
		            var len = content.length;
		            for (var count = 0;count < len;count++) 
		            {
		            	ch = content.charCodeAt(count);
		                k = (crc ^ ch) & 0xFF;
		                l = crcTable[k];
		                crc = (crc >>> 8) ^ l;
		            }
	    		}
	    		else
	    		{
	    			var ch = 0;
		            var k = 0;
		            var l = 0;
	    			var len = content.length;
	    			for (var count = 0;count < len;count++) 
		            {
	    				ch = content[count];
	    				k = (crc ^ ch) & 0xFF;
	    				l = crcTable[k];
	    				crc = (crc >>> 8) ^ l;
		            }
	    		}
	    		return crc ^ (-1);
	        };
	        
	        var buildUint8Array = function(content)
	        {
	        	var retValue = new Uint8Array(content.length);
	            for (var count = 0; count < content.length; count++) 
	            {
	            	retValue[count] = content.charCodeAt(count);
	            }
	            return retValue;
	        };
	        
	        //http://www.navioo.com/javascript/tutorials/Javascript_utf8_encode_1529.html
	        // Encodes an ISO-8859-1 string to UTF-8    
	        var utf8_encode = function(str) 
	    	{
	        	var retValue = "";
	    		var str = str.replace(/\r\n/g, "\n");
	    		var len = str.length;
	    		var start = 0;
	    		var end = 0;
	    		var enc = null;
	    		var ch = null;
	    		for(var count = 0;count < len;count++)
	    		{
	    			ch = str.charCodeAt(count);
	    			enc = null;
	    			if(ch < 128)
	    			{
	    				end++;
	    			}
	    			else if(ch > 127 && ch < 2048)
	    			{
	    				enc = String.fromCharCode(ch >> 6 | 192);
	    				enc += String.fromCharCode((ch & 63) | 128);
	    			}
	    			else
	    			{
	    				enc = String.fromCharCode((ch >> 12) | 224);
	    				enc += String.fromCharCode(((ch >> 6) & 63) | 128);
	    				enc += String.fromCharCode((ch & 63) | 128);
	    			}
	    			if (enc != null) 
	    			{  
    		            if (end > start) 
    		            {  
    		            	retValue += str.substring(start, end);  
    		            }  
    		            retValue += enc;  
    		            start = end = count + 1;  
    		        }  
	    		}
	    		if (end > start) 
	    		{  
	    			retValue += str.substring(start,str.length);  
	    	    } 
	    		return retValue;
	        };
	        
	        //http://www.navioo.com/javascript/tutorials/Javascript_utf8_decode_1528.html
	        // Converts a UTF-8 encoded string to ISO-8859-1    
	        var utf8_decode = function(str) 
	    	{
	        	var arrReturn = [];
	        	var count = 0;
	        	var retCount = 0;
	        	var char1 = 0;
	        	var char2 = 0;
	        	var char3 = 0;  
	            str += "";  
	            while (count < str.length) 
	            {  
	                char1 = str.charCodeAt(count);  
	                if (char1 < 128) 
	                {  
	                    arrReturn[retCount++] = String.fromCharCode(char1);  
	                    count++;  
	                } 
	                else if ((char1 > 191) && (char1 < 224)) 
	                {  
	                    char2 = str.charCodeAt(count+1);  
	                    arrReturn[retCount++] = String.fromCharCode(((char1 & 31) << 6) | (char2 & 63));  
	                    count += 2;  
	                } 
	                else 
	                {  
	                    char2 = str.charCodeAt(count+1);  
	                    char3 = str.charCodeAt(count+2);  
	                    arrReturn[retCount++] = String.fromCharCode(((char1 & 15) << 12) | ((char2 & 63) << 6) | (char3 & 63));  
	                    count += 3;  
	                }  
	            }  
	            return arrReturn.join('');  
	    	};
	        
	        var decToHex = function(number, bytes) 
	        {
	        	var retValue = "";
	        	for(var count = 0;count < bytes;count++)
	    		{
	        		retValue += String.fromCharCode(number & 0xFF);
	        		number = number >>> 8;
	    		}
	        	return retValue;
	        };
	        
	        var fillArrayWithString = function(str,arrData) 
	        {
	        	for (var count = 0;count < str.length;count++) 
	        	{
	        		arrData[count] = str.charCodeAt(count) & 0xFF;
	            }
	            return arrData;
	        };
	        
	        var convertTime = function(date)
	        {
	        	 var hour = date.getUTCHours();
	        	 hour = hour << 6;
	        	 hour = hour | date.getUTCMinutes();
	        	 hour = hour << 5;
	        	 hour = hour | date.getUTCSeconds() / 2;
	        	 return hour;
	        };
	        
	        var convertDate = function(date)
	        {
	        	var retDate = date.getUTCFullYear() - 1980;
	        	retDate = retDate << 4;
	        	retDate = retDate | (date.getUTCMonth() + 1);
	        	retDate = retDate << 5;
	        	retDate = retDate | date.getUTCDate();
	        	return retDate;
	        };
	        
	        var addSlashAtEnd = function(path) 
	    	{
	    	    if (path.slice(-1) !== "/") 
	    	    {
	    	        path += "/";
	    	    }
	    	    return path;
	    	};
	    	
	    	var getParentFolder = function(path) 
	    	{
	    	    if (path.slice(-1) === '/') 
	    	    {
	    	        path = path.substring(0, path.length - 1);
	    	    }
	    	    var lastSlash = path.lastIndexOf('/');
	    	    return (lastSlash > 0) ? path.substring(0, lastSlash) : "";
	    	};
	    	
	    	var getDataType = function(data) 
	    	{
	    	    if (typeof data === "string") 
	    	    {
	    	        return "string";
	    	    }
	    	    if (Object.prototype.toString.call(data) === "[object Array]") 
	    	    {
	    	        return "array";
	    	    }
	    	    if (typeof Buffer !== "undefined" && data instanceof Buffer) 
	    	    {
	    	        return "nodebuffer";
	    	    }
	    	    if (data instanceof Uint8Array) 
	    	    {
	    	        return "uint8array";
	    	    }
	    	    if (data instanceof ArrayBuffer) 
	    	    {
	    	        return "arraybuffer";
	    	    }
	    	};
	    	
	    	var base64Decode = function(data) 
	    	{
	    		var chr1, chr2, chr3;
	    	    var enc1, enc2, enc3, enc4;
	    	    var i = 0, resultIndex = 0;
	    	    
	    	    if(data.indexOf('base64,') > -1)
	    	    {
	    	    	var index = data.indexOf('base64,') + 'base64,'.length;
		    	    data = data.substring(index);
	    	    }
	    	    data = data.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	    	    var totalLength = data.length * 3 / 4;
	    	    if(data.charAt(data.length - 1) === base64Key.charAt(64)) 
	    	    {
	    	        totalLength--;
	    	    }
	    	    if(data.charAt(data.length - 2) === base64Key.charAt(64)) 
	    	    {
	    	        totalLength--;
	    	    }
	    	    //totalLength is base64 expected length
	    	    if (totalLength % 1 !== 0) 
	    	    {
	    	        throw new Error("Invalid base64 data");
	    	    }
	    	    var retValue = new Uint8Array(totalLength|0);
	    	    while (i < data.length) 
	    	    {
	    	        enc1 = base64Key.indexOf(data.charAt(i++));
	    	        enc2 = base64Key.indexOf(data.charAt(i++));
	    	        enc3 = base64Key.indexOf(data.charAt(i++));
	    	        enc4 = base64Key.indexOf(data.charAt(i++));

	    	        chr1 = (enc1 << 2) | (enc2 >> 4);
	    	        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	    	        chr3 = ((enc3 & 3) << 6) | enc4;

	    	        retValue[resultIndex++] = chr1;

	    	        if (enc3 !== 64) 
	    	        {
	    	            retValue[resultIndex++] = chr2;
	    	        }
	    	        if (enc4 !== 64) 
	    	        {
	    	            retValue[resultIndex++] = chr3;
	    	        }
	    	    }

	    	    return retValue;
	    	};
	    	
	    	var downloadFile = function(fileName,content)
	        {
	        	if ("msSaveOrOpenBlob" in window.navigator) 
	        	{
	                window.navigator.msSaveOrOpenBlob(content, fileName);
	            }
	            else 
	            {
	                var element = document.createElement("a");
	                var url = window.URL.createObjectURL(content);
	                element.setAttribute("href", url);
	                element.setAttribute("download", fileName);
	                element.style.display = "none";
	                document.body.appendChild(element);
	                element.click();
	                window.URL.revokeObjectURL(url);
	                document.body.removeChild(element);
	            }
	        };
	        
	        initialize();
	        
	        self.getFromCrc32Table = getFromCrc32Table;
	        self.buildUint8Array = buildUint8Array;
	        self.utf8_encode = utf8_encode;
	        self.utf8_decode = utf8_decode;
	        self.decToHex = decToHex;
	        self.fillArrayWithString = fillArrayWithString;
	        self.convertTime = convertTime;
	        self.convertDate = convertDate;
	        self.addSlashAtEnd = addSlashAtEnd;
	        self.getParentFolder = getParentFolder;
	        self.getDataType = getDataType;
	        self.base64Decode = base64Decode;
	        self.downloadFile = downloadFile;
	    };
	    
		initialize();
		
		self.addFolder = addFolder;
		self.addFolders = addFolders;
		self.addFile = addFile;
		self.getBlob = getBlob;
		self.getFile = getFile;
		self.downloadFile = downloadFile;
	};
	
	return NSZip;
})();
nsModuleExport(this,"NSZip",NSZip);var nsExtendPrototype = (function()
{
	var nsExtendPrototype = function(source,destination) 
	{
		if(source && destination)
		{
			destination.prototype = Object.create(source.prototype);
			destination.prototype.constructor = destination;
			destination.prototype.base = source.prototype;
			return source.prototype;
		}
		return null;
	};
	return nsExtendPrototype;
})();

var NSDocxExport = (function()
{
	var NSDocxExport = function(config)
	{
		this.__config = config;
		this.util = null;
		this.__exportUtil = null;
		this.__setting = {};
		this.__objOrientation = {};
		this.__arrDefault = [];
		this.__arrOverride = [];
		this.__arrRelationship = [];
		this.__relationshipID = 0;
		this.__extraFiles = {};
		this.__arrChildren = [];
		this.__pageSection = null;
		this.__styles = null;
		this.__enableChunk = true;
		
		this.__initialize();
	};
	
	NSDocxExport.prototype.process = function()
	{
		var self = this;
		var objPromise = new Promise(function(resolve,reject)
		{
			var mimeType = "application/vnd.openxmlformats-officedocument.wordprocessingml.document";
			var zip = new NSZip();
			self.__save(zip).then(function(){
				zip.downloadFile(self.__setting.fileName,mimeType);
				resolve(true);
			}).catch(function(error){
				reject(error);
			});
		});
		return objPromise;
	};
	
	NSDocxExport.prototype.addSection = function()
	{
		this.__enableChunk = false;
		var section = new Section(this);
	    this.__arrChildren.push(section)
	    return section;
	};
	
	NSDocxExport.prototype.addParagraph = function(option)
	{
		this.__enableChunk = false;
		var paragraph = new Paragraph(this,option);
	    this.__arrChildren.push(paragraph)
	    return paragraph;
	};
	
	NSDocxExport.prototype.addTable = function(option)
	{
		this.__enableChunk = false;
		var table = new Table(this,option);
	    this.__arrChildren.push(table)
	    return table;
	};
	
	NSDocxExport.prototype.addHeader = function(type)
	{
		//this.__enableChunk = false;
		var header = this.__pageSection.addHeader(type);
	    return header;
	};
	
	NSDocxExport.prototype.addFooter = function(type)
	{
		//this.__enableChunk = false;
		var footer = this.__pageSection.addFooter(type);
	    return footer;
	};
	
	NSDocxExport.prototype.styles = function(value)
	{
		if(value && value instanceof Styles)
		{
			this.__styles = value;
		}
		else
		{
			!this.__styles && (this.__styles = new Styles(this,value));
		}
		return this.__styles;
	};
	
	NSDocxExport.prototype.getPageSection = function()
	{
		return this.__pageSection;
	};
	
	NSDocxExport.prototype.__initialize = function()
	{
		if(!this.__config)
		{
			this.__config = {};
		}
		this.util = new NSUtil();
		this.__exportUtil = new ExportUtil(this.util);
		this.__setting = {
			fileName: this.__config["fileName"] || "download",
			htmlSetting: this.__config["htmlSetting"],
			printSetting: this.__config["printSetting"],
			styles: this.__config["styles"],
		};
		this.__setHtmlSetting();
		this.__setPrintSetting();
		this.__initMargins();
		this.__initOrientation();
		this.__pageSection = new Section(this);
		if(this.__setting.fileName.indexOf(".") === -1) 
		{
			this.__setting.fileName = this.__setting.fileName + ".docx";
        }
		var arrStyles = this.__getDefaultStyle();
		var styles = this.__setting.styles || {};
		if(styles.styles && styles.styles.length)
		{
			arrStyles = arrStyles.concat(styles.styles);
		}
		styles.styles = arrStyles;
		this.styles(styles);
	};
	
	//by default TableNormal and TableGrid are available for table
	NSDocxExport.prototype.__getDefaultStyle = function()
	{
		var arrDefault = [];
		var tblNormal = {
	            id: "TableNormal",
	            type: "table",
	            name: "Normal Table",
	            basedOn: "Normal",
	            uiPriority: "99",
	            semiHidden: true,
	            unhideWhenUsed: true,
	            quickFormat: true,
	            table: {
	            	cellMargin: { top: {width: 0,type: "dxa"}, 
	            				  left: {width: 108,type: "dxa"},
	            				  bottom: {width: 0,type: "dxa"}, 
	            				  right: {width: 108,type: "dxa"}, 
	            				},
	            },
	        };
		arrDefault.push(tblNormal);
		var tblGrid = {
	            id: "TableGrid",
	            type: "table",
	            name: "Table Grid",
	            basedOn: "TableNormal",
	            uiPriority: "59",
	            paragraph:{spacing: { after: 0 },},
	            table: {
	            	borders: {top: {color: "auto",space: 0,size: 4,value: "single"},
	            			  left: {color: "auto",space: 0,size: 4,value: "single"},
	            			  bottom: {color: "auto",space: 0,size: 4,value: "single"},
	            			  right: {color: "auto",space: 0,size: 4,value: "single"},
	            			  insideH: {color: "auto",space: 0,size: 4,value: "single"},
	            			  insideV: {color: "auto",space: 0,size: 4,value: "single"},
	            			 },
	            	cellMargin: { top: {width: 0,type: "dxa"}, 
	            				  left: {width: 108,type: "dxa"},
	            				  bottom: {width: 0,type: "dxa"}, 
	            				  right: {width: 108,type: "dxa"}, 
	            				},
	            },
	        };
		arrDefault.push(tblGrid);
		return arrDefault;
	};
	
	NSDocxExport.prototype.__setPrintSetting  = function()
	{
		var printSetting = this.__setting.printSetting || {};
		this.__setting.printSetting = {
				orientation: printSetting["orientation"] || "portrait",
				margins: printSetting["margins"]
		};
	};
	
	NSDocxExport.prototype.__initOrientation = function()
	{
		this.__objOrientation = {landscape:{width: 16838,height: 11906,orientation: "landscape"},
						  portrait:{width: 11906,height: 16838,orientation: "portrait"},
						 };
	};
	
	NSDocxExport.prototype.__initMargins = function()
	{
		/*var margins = this.__setting.printSetting.margins;
		if(margins)
		{
			this.__setting.printSetting.margins = {
					 top: this.util.isUndefinedOrNull(margins["top"]) ? null : parseInt(margins["top"]),
				     right: this.util.isUndefinedOrNull(margins["right"]) ? null : parseInt(margins["right"]),
				     bottom: this.util.isUndefinedOrNull(margins["bottom"]) ? null : parseInt(margins["bottom"]),
				     left: this.util.isUndefinedOrNull(margins["left"]) ? null : parseInt(margins["left"]),
				     header: this.util.isUndefinedOrNull(margins["header"]) ? null : parseInt(margins["header"]),
				     footer: this.util.isUndefinedOrNull(margins["footer"]) ? null : parseInt(margins["footer"]),
				     gutter: this.util.isUndefinedOrNull(margins["gutter"]) ? null: parseInt(margins["gutter"]),	
			};
		}*/
		var margins = this.__setting.printSetting.margins || {};
		this.__setting.printSetting.margins = {
			 top: this.util.isUndefinedOrNull(margins["top"]) ? 1440 : parseInt(margins["top"]),
		     right: this.util.isUndefinedOrNull(margins["right"]) ? 1440 : parseInt(margins["right"]),
		     bottom: this.util.isUndefinedOrNull(margins["bottom"]) ? 1440 : parseInt(margins["bottom"]),
		     left: this.util.isUndefinedOrNull(margins["left"]) ? 1440 : parseInt(margins["left"]),
		     header: this.util.isUndefinedOrNull(margins["header"]) ? 708 : parseInt(margins["header"]),
		     footer: this.util.isUndefinedOrNull(margins["footer"]) ? 708 : parseInt(margins["footer"]),
		     gutter: this.util.isUndefinedOrNull(margins["gutter"]) ? 0: parseInt(margins["gutter"]),	
		};
	};
	
	NSDocxExport.prototype.__save = function(zip)
	{
		var self = this;
		var resolveOtherFiles = function()
		{
			word.addFile("document.xml",self.__getDocumentFile());
			if(self.__styles)
			{
				var styleXml = self.__styles.toXml();
				if(styleXml)
				{
					self.__addFile(null,"styles.xml","http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles","application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml")
					console.log(styleXml);
					word.addFile("styles.xml",styleXml);
				}
			}
			word.addFile("numbering.xml",);
			var wordRels = word.addFolder("_rels");
			wordRels.addFile("document.xml.rels",self.__getWordRels());
			zip.addFile("_rels/.rels", self.__getRels());
			zip.addFile("[Content_Types].xml", self.__getContentTypesXml());
			self.__addExtraFiles.call(self,zip,word);
		};
		var objPromise = null;
		var word = zip.addFolder("word");
		if(this.__isChunk())
		{
			objPromise = new Promise(function(resolve,reject)
			{
				
				self.__getHtmlContent(word).then(function(data){
					if(data)
					{
						self.__addFile(null,"afchunk.mht","http://schemas.openxmlformats.org/officeDocument/2006/relationships/aFChunk","message/rfc822")
						//self.__arrOverride.push({partName:"/word/afchunk.mht",contentType:"message/rfc822"});
						//self.__arrRelationship.push({id:"htmlChunk",type:"http://schemas.openxmlformats.org/officeDocument/2006/relationships/aFChunk",target:"/word/afchunk.mht"});
						word.addFile("afchunk.mht",data);
					}
					resolveOtherFiles();
					resolve(true);
				});
			});
		}
		else
		{
			
			objPromise = new Promise(function(resolve,reject)
			{
				resolveOtherFiles();
				resolve(true);
			});
		}
		return objPromise;
	};
	
	NSDocxExport.prototype.__getContentTypesXml = function()
	{
		var isChunk = this.__isChunk();
		var objDefault = {rels:{extension:"rels",contentType:"application/vnd.openxmlformats-package.relationships+xml",isDefault:true},
						  xml:{extension:"xml",contentType:"application/xml",isDefault:true},
						  png:{extension:"png",contentType:"image/png",isDefault:!isChunk},
						  jpeg:{extension:"jpeg",contentType:"image/jpeg",isDefault:!isChunk},
						  jpg:{extension:"jpg",contentType:"image/jpeg",isDefault:!isChunk},
						  bmp:{extension:"bmp",contentType:"image/bmp",isDefault:!isChunk},
						  gif:{extension:"gif",contentType:"image/gif",isDefault:!isChunk}
		};
		var objOverride = {document:{partName:"/word/document.xml",contentType:"application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml"},
						  };
		
		var arrChild = [];
		var item = null;
		var key = null;
		var count = 0;
		for(key in objDefault)
		{
			item = objDefault[key];
			if(item.isDefault)
			{
				arrChild.push(this.__exportUtil.getXML({
					name: "Default",
					attributes: {"Extension": item.extension,"ContentType": item.contentType}
				}));
			}
		}
		for(count = 0;count < this.__arrDefault.length;count++)
		{
			item = objDefault[this.__arrDefault[count]];
			if(item && !item.isDefault)
			{
				arrChild.push(this.__exportUtil.getXML({
					name: "Default",
					attributes: {"Extension": item.extension,"ContentType": item.contentType}
				}));
			}
		}
		for(key in objOverride)
		{
			item = objOverride[key];
			arrChild.push(this.__exportUtil.getXML({
				name: "Override",
				attributes: {"PartName": item.partName,"ContentType": item.contentType}
			}));
		}
		for(count = 0;count < this.__arrOverride.length;count++)
		{
			item = this.__arrOverride[count];
			if(item && !item.isDefault)
			{
				arrChild.push(this.__exportUtil.getXML({
					name: "Override",
					attributes: {"PartName": item.partName,"ContentType": item.contentType}
				}));
			}
		}
		return this.__exportUtil.getXML({
			name: "Types",
			ns: "contentTypes",
			children: arrChild
		});
	};
	
	NSDocxExport.prototype.__getRels = function()
	{
		var rels = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\n ' +
		'<Relationships xmlns="http://schemas.openxmlformats.org/package/2006/relationships">\n ' +
		'<Relationship Id="Id1" Type="http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument" Target="/word/document.xml"/>\n ' +
		'</Relationships>';
		
		return rels;
	};
	
	NSDocxExport.prototype.__getDocumentFile = function()
	{
		var printSetting = this.__setting.printSetting;
		var orientation = printSetting.orientation;
		if(orientation)
		{
			var itemOrient = this.__objOrientation[orientation.toLowerCase()];
			if(itemOrient)
			{
				var pageSize = this.__pageSection.pgSz();
				pageSize.width(itemOrient.width);
				pageSize.height(itemOrient.height);
				pageSize.orientation(itemOrient.orientation);
			}
			else
			{
				this.util.throwNSError("NSDocxExport","Orientation entered is not valid");
			}
		}
		var margins = this.__setting.printSetting.margins;
		if(margins)
		{
			var pageMargins = this.__pageSection.pgMar();
			pageMargins.top(margins.top);
			pageMargins.right(margins.right);
			pageMargins.bottom(margins.bottom);
			pageMargins.left(margins.left);
			pageMargins.header(margins.header);
			pageMargins.footer(margins.footer);
			pageMargins.gutter(margins.gutter);
		}
				
		var objDocAttr =  {"xmlns:w":"http://schemas.openxmlformats.org/wordprocessingml/2006/main",
				  		   "xmlns:m":"http://schemas.openxmlformats.org/officeDocument/2006/math",
						   "xmlns:r":"http://schemas.openxmlformats.org/officeDocument/2006/relationships",
						   "xmlns:wp":"http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing",
						   "xmlns:a":"http://schemas.openxmlformats.org/drawingml/2006/main",
						   "xmlns:ns6":"http://schemas.openxmlformats.org/schemaLibrary/2006/main",
						   "xmlns:c":"http://schemas.openxmlformats.org/drawingml/2006/chart",
						   "xmlns:ns8":"http://schemas.openxmlformats.org/drawingml/2006/chartDrawing",
						   "xmlns:dgm":"http://schemas.openxmlformats.org/drawingml/2006/diagram",
						   "xmlns:pic":"http://schemas.openxmlformats.org/drawingml/2006/picture",
						   "xmlns:ns11":"http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing",
						   "xmlns:dsp":"http://schemas.microsoft.com/office/drawing/2008/diagram",
						   "xmlns:ns13":"urn:schemas-microsoft-com:office:excel",
						   "xmlns:o":"urn:schemas-microsoft-com:office:office",
						   "xmlns:v":"urn:schemas-microsoft-com:vml",
						   "xmlns:w10":"urn:schemas-microsoft-com:office:word",
						   "xmlns:ns17":"urn:schemas-microsoft-com:office:powerpoint",
						   "xmlns:odx":"http://opendope.org/xpaths",
						   "xmlns:odc":"http://opendope.org/conditions",
						   "xmlns:odq":"http://opendope.org/questions",
						   "xmlns:odi":"http://opendope.org/components",
						   "xmlns:odgm":"http://opendope.org/SmartArt/DataHierarchy",
						   "xmlns:ns24":"http://schemas.openxmlformats.org/officeDocument/2006/bibliography",
						   "xmlns:ns25":"http://schemas.openxmlformats.org/drawingml/2006/compatibility",
						   "xmlns:ns26":"http://schemas.openxmlformats.org/drawingml/2006/lockedCanvas"
		};
		var arrBody = [];
		if(this.__isChunk())
		{
			var id = null;
			for(var count = 0;count < this.__arrRelationship.length;count++)
			{
				if(this.__arrRelationship[count].target == "afchunk.mht")
				{
					id = this.__arrRelationship[count].id;
					break;
				}
			}
			if(id)
			{
				arrBody.push("<w:altChunk r:id=\"" + id + "\" />");
			}
		}
		else
		{
			var arrChildren = this.__getWordChildren();
			arrBody = arrBody.concat(arrChildren);
		}
		arrBody.push(this.__pageSection.toXml());
		var body = this.__exportUtil.getXML({
			name: 'w:body',
			children: arrBody
		});
		console.log(body);
		return this.__exportUtil.getXML({
			name: 'w:document',
			addXmlPrefix: true,
			attributes: objDocAttr,
			children: [body]
		});
	};
	
	NSDocxExport.prototype.__getWordRels = function()
	{
		var item = null;
		var arrChild = [];
		for(var count = 0;count < this.__arrRelationship.length;count++)
		{
			item = this.__arrRelationship[count];
			if(item)
			{
				arrChild.push(this.__exportUtil.getXML({
					name: 'Relationship',
					attributes: {'Id': item.id,'Type': item.type,'Target': item.target}
				}));
			}
		}
		var relationships = this.__exportUtil.getXML({
			name: 'Relationships',
			addXmlPrefix: true,
			attributes: {xmlns:"http://schemas.openxmlformats.org/package/2006/relationships"},
			children: arrChild
		});
		return relationships;
	};
	
	NSDocxExport.prototype.__addExtraFiles = function(zip,word)
	{
		if(this.__extraFiles && Object.keys(this.__extraFiles).length)
		{
			var arrFile = [];
			var item = null;
			var xml = null;
			var file = null;
			for(var key in this.__extraFiles)
			{
				arrFile = this.__extraFiles[key];
				if(arrFile && arrFile.length)
				{
					for(var count = 0;count < arrFile.length;count++)
					{
						item = arrFile[count];
						if(item)
						{
							file = item.file;
							if(file)
							{
								if(this.util.isString(file))
								{
									xml = file;
								}
								else
								{
									xml = file.toXml();
								}
								if(xml)
								{
									console.log(xml);
									zip.addFile(item.path + item.fileName, xml);
								}
							}
						}
					}
				}
			}
		}
	};
	
	NSDocxExport.prototype.__addFile = function(file,fileType,relationType,overrideType)
	{
		var fileName = fileType;
		var rId = null;
		if(file)
		{
			fileName = this.__addExtraFile(fileType,file)
		}
		if(fileName)
		{
			rId = this.__addRelationship(file,relationType,fileName);
			this.__addOverride(overrideType,"/word/" + fileName);
			return {fileName: fileName,id: rId};
		}
		return null;
	};
	
	NSDocxExport.prototype.__addExtraFile = function(fileType,file,path,ext)
	{
		if(fileType && file)
		{
			fileType = fileType.toLowerCase();
			if(!this.__extraFiles[fileType])
			{
				this.__extraFiles[fileType] = [];
			}
			ext = ext || "xml";
			path = path || "word/"
			var fileName = fileType + (this.__extraFiles[fileType].length + 1) + "." + ext;
			this.__extraFiles[fileType].push({file: file,fileName: fileName,path: path});
			return fileName;
		}
		return null;
	};
	
	NSDocxExport.prototype.__addRelationship = function(file,type,target)
	{
		if(type && target)
		{
			var id = "rId" + (++this.__relationshipID);
			this.__arrRelationship.push({id:id,type:type,target:target});
			return id;
		}
	};
	
	NSDocxExport.prototype.__addOverride = function(contentType,partName)
	{
		if(contentType && partName)
		{
			this.__arrOverride.push({contentType:contentType,partName:partName});
		}
	};
	
	NSDocxExport.prototype.__isChunk = function()
	{
		//return !(this.__arrChildren && this.__arrChildren.length)
		return this.__enableChunk;
	};
	
	/* word related functions */
	NSDocxExport.prototype.__getWordChildren = function()
	{
		var arrChildren = [];
		var item = null;
		var xml = null;
		var length = this.__arrChildren.length;
		for(var count = 0;count < length;count++)
		{
			item = this.__arrChildren[count];
			if(item)
			{
				if(this.util.isString(item))
				{
					arrChildren.push(item);
				}
				else
				{
					xml = item.toXml();
					if(xml)
					{
						arrChildren.push(xml);
					}
				}
			}
		}
		return arrChildren;
	};
	
	/* end of word related functions */
	
	/* html related functions */
	
	NSDocxExport.prototype.__setHtmlSetting  = function()
	{
		var htmlSetting = this.__setting.htmlSetting || {};
		this.__setting.htmlSetting = {
				element: htmlSetting["element"],
				html: htmlSetting["html"],
				htmlStyle: htmlSetting["htmlStyle"],
				pageBreakTag: htmlSetting["pageBreakTag"],
				enablePageNumber: Boolean.parse(htmlSetting["enablePageNumber"]),
				loopNodesCallback: htmlSetting["loopNodesCallback"]// should be discouraged as it can be costly operation for large docs 
		};
	};
	
	NSDocxExport.prototype.__getHtmlContent = function(wordFolder)
	{
		var self = this;
		var objPromise = new Promise(function(resolve,reject)
		{
			var htmlSetting = self.__setting.htmlSetting;
			if(htmlSetting.element || htmlSetting.html)
			{
				var html = htmlSetting.html;
				if(!html)
				{
					var element = self.util.getElement(htmlSetting.element);
					if(element)
					{
						html = element.innerHTML;
					}
					else
					{
						self.util.throwNSError("NSDocxExport","Element does not exists as defined in config");
					}
				}
				if(html)
				{
					self.__parseImages(html).then(function(objData){
						if(objData)
						{
							html = objData.html;
							var arrImages = objData.arrImages;
							var styles = htmlSetting.htmlStyle || "";
							var startHtml = "";
							var endHtml = "";
							var extraCSS = "";
							if(htmlSetting.enablePageNumber)
							{
								startHtml = "<div class=\"Section1\">";
								endHtml = "<table id=\"hrdftrtbl\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\"> <tr> <td> <div style=\"mso-element:footer\" id=\"f1\"> <p class=\"MsoFooter\"> <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"> <tr> <td align=\"center\" class=\"footer\"> <g:message code=\"offer.letter.page.label\"/> <span style=\"mso-field-code: PAGE \"></span> of <span style=\"mso-field-code: NUMPAGES \"></span> </td> </tr> </table> </p> </div> </td> </tr> </table> </div>";
								extraCSS = "p.MsoHeader, li.MsoHeader, div.MsoHeader{     margin:0in;     margin-top:.0001pt;     mso-pagination:widow-orphan;     tab-stops:center 3.0in right 6.0in; } p.MsoFooter, li.MsoFooter, div.MsoFooter{     margin:0in 0in 1in 0in;     margin-bottom:.0001pt;     mso-pagination:widow-orphan;     tab-stops:center 3.0in right 6.0in; } .footer {     font-size: 9pt; } @page Section1{     size:8.5in 11.0in;     margin:0.5in 0.5in 0.5in 0.5in;     mso-header-margin:0.5in;     mso-header:h1;     mso-footer:f1;     mso-footer-margin:0.5in;     mso-paper-source:0; } div.Section1{     page:Section1; } table#hrdftrtbl{     margin:0in 0in 0in 9in; }";
							}
							html = startHtml + html + endHtml;
							if(htmlSetting["pageBreakTag"])
							{
								html = html.replaceAll(htmlSetting["pageBreakTag"],"<br clear=all style='mso-special-character:line-break;page-break-before:always'>");
							}
							styles = styles + extraCSS;
							html = self.__getDocHtml(html,arrImages,styles);
							var strData = self.__convertHtmlToMht(html);
							resolve(strData);
						}
						else
						{
							resolve(null);
						}
					});
				}
				else
				{
					resolve(null);
				}
			}
			else
			{
				self.util.debug("NSDocxExport","Element and HTML are not defined in config");
				resolve(null);
			}
		});
		return objPromise;
	};
	
	NSDocxExport.prototype.__parseImages = function(html)
	{
		var self = this;
		var replacerCallback = function(match,contentType,contentEncoding,encodedContent) 
		{
		      var index = arrImages.length;
		      var extension = contentType.split('/')[1];
		      var contentLocation = "file:///C:/fake/image" + index + "." + extension;
		      arrImages.push(getImageString(contentType,contentEncoding,contentLocation,encodedContent));
		      return "\"" + contentLocation + "\"";
		};
		var getImageString = function(contentType,contentEncoding,contentLocation,encodedContent)
		{
			var str = "Content-Type:" + self.__exportUtil.getNonNullString(contentType);
			str += self.__exportUtil.newLine + "Content-Transfer-Encoding: " + self.__exportUtil.getNonNullString(contentEncoding);
			str += self.__exportUtil.newLine + "Content-Location: " + self.__exportUtil.getNonNullString(contentLocation);
			str += self.__exportUtil.newLine + self.__exportUtil.newLine + self.__exportUtil.getNonNullString(encodedContent);
			str = "------=mhtDocumentPart" + self.__exportUtil.newLine + str + self.__exportUtil.newLine;
			return str;
		};
		var arrImages = [];
		var regex = /"data:(\w+\/\w+);(\w+),(\S+)"/g;
		var objPromise = new Promise(function(resolve,reject)
		{
			if(html) 
			{
				self.__replaceImagesByBase64(html).then(function(paramHtml){
					html = paramHtml;
					if (!/<img/g.test(html)) 
					{
						resolve({html: html,arrImages: arrImages});
					}
					else
					{
						html = html.replace(regex,replacerCallback);
						resolve({html: html,arrImages: arrImages});
					}
				});
			}
			else
			{
				resolve(null);
			}
		});
		return objPromise;
	};
	
	NSDocxExport.prototype.__replaceImagesByBase64 = function(html)
	{
		var parser = new DOMParser();
		var tempDoc = parser.parseFromString(html,"text/html");
		var arrImages = tempDoc.querySelectorAll("img");
		var length = arrImages.length;
		var resolved = 0;
		var self = this;
		var objPromise = new Promise(function(resolve,reject)
		{
			if(length)
			{
				var increaseResolved = function()
				{
					resolved++;
					if(resolved == length)
					{
						resolve(tempDoc.getElementsByTagName("html")[0].outerHTML);
					}
				};
				for(var count = 0;count < length;count++)
				{
					var img = arrImages[count];
					var src = img.getAttribute("src");
					if(!self.util.isBase64String(src))
					{
						var callback = function(paramImg,base64,orignalSrc,hasError,errorDetails)
						{
							//orignalSrc can be src or image itself
							//paramImg is always giving last image in the outer loop so that is why looping orignalSrc to find the image
							if(base64)
							{
								var tempImg = null;
								for(var tempCount = 0;tempCount < length;tempCount++)
								{
									tempImg = arrImages[tempCount];
									if(tempImg == orignalSrc || tempImg.getAttribute("src") == orignalSrc)
									{
										if(hasError)
										{
											self.util.warning("NSDocxExport","The image with source " + tempImg.getAttribute("src") + " has issues.So it is getting deleted.The error detials are :: " + errorDetails);
											if(tempImg.parentNode)
											{
												tempImg.parentNode.removeChild(tempImg);
											}
										}
										else
										{
											tempImg.setAttribute("src",base64);
										}
										break;
									}
								}
							}
							increaseResolved();
						};
						if(self.util.isSVGString(src))
						{
							self.util.convertSvgToBase64(src,callback);
						}
						else
						{
							//sending img and not src as we have to also pass the width
							//this.util.convertImageToBase64(src,callback);
							self.util.convertImageToBase64(img,true).then(function(item){
								if(item)
								{
									callback(img,item.base64,item.param,item.hasError,item.errorDetails);
								}
								else
								{
									increaseResolved();
								}
							});
						}
					}
					else
					{
						increaseResolved();
					}
				}
			}
			else
			{
				resolve(tempDoc.getElementsByTagName("html")[0].outerHTML);
			}
		});
		return objPromise;
	};
	
	NSDocxExport.prototype.__getDocHtml = function(html,arrImages,styles)
	{
		var self = this;
		function addStyle(paramStyle) 
		{ 
            var css = doc.createElement("style"); 
            css.setAttribute("id","styleNSDocxExport"); 
            css.setAttribute("type","text/css"); 
            if(css.styleSheet)
            {
            	css.styleSheet.cssText = styles; 
            }
            else
            {
            	css.appendChild(doc.createTextNode(styles));
            }
            doc.getElementsByTagName("head")[0].appendChild(css); 
        };
        function loopElements()
        {
        	if(self.__setting.htmlSetting.loopNodesCallback)
        	{
        		var callback = self.__setting.htmlSetting.loopNodesCallback;
        		var arrElement = doc.querySelectorAll("body *");
        		var length = arrElement.length;
        		for(var count = 0;count < length;count++)
        		{
        			callback(arrElement[count]);
        		}
        	}
        };
        var parser = new DOMParser();
    	var doc = parser.parseFromString(html, "text/html");
    	loopElements();
    	if(styles)
    	{
    		addStyle(styles);
    	}
		var content = doc.getElementsByTagName("html")[0].outerHTML;
		content = content.replace(/\=/g, '=3D');
		var strImages = (arrImages && arrImages.length) ? arrImages.join("") : "";
		content += this.__exportUtil.newLine + this.__exportUtil.newLine + this.__exportUtil.getNonNullString(strImages);
		return content;
	};
	
	NSDocxExport.prototype.__convertHtmlToMht = function(html)
	{
		var mimeTypeToAdd = 'MIME-Version: 1.0\nContent-Type: multipart/related;\n    type="text/html";\n    boundary="----=mhtDocumentPart"\nX-MimeOLE: Produced By Microsoft MimeOLE V6.1.7601.17609\n\nThis is a multi-part message in MIME format.\n\n------=mhtDocumentPart\nContent-Type: text/html;\n    charset="utf-8"\nContent-Transfer-Encoding: quoted-printable\nContent-Location: file://\\\\fake\\document.html\n\n';
	    var endHtml = this.__exportUtil.newLine + this.__exportUtil.newLine + "------=mhtDocumentPart--" + this.__exportUtil.newLine;
	    return mimeTypeToAdd + html + endHtml;
	};
	
	/* end of html related functions */
	
	var BaseElement = function()
	{
	};
	
	BaseElement.prototype.init = function(docxRef)
	{
		this.util = new NSUtil();
		this.__docxRef = docxRef;
		this.__exportUtil = new ExportUtil(this.util);
		this.__children = [];
	};
	
	BaseElement.prototype.getChildrenForXml = function()
	{
		var arrChildren = [];
		var item = null;
		var xml = null;
		var length = this.__children.length;
		for(var count = 0;count < length;count++)
		{
			item = this.__children[count];
			if(item)
			{
				if(this.util.isString(item))
				{
					arrChildren.push(item);
				}
				else
				{
					xml = item.toXml.call(item);
					if(xml)
					{
						arrChildren.push(xml);
					}
				}
			}
		}
		return arrChildren;
	};
	
	BaseElement.prototype.toXml = function(xmlTag,attributes)
	{
		var arrChildren = this.getChildrenForXml();
		var item = {name: xmlTag};
		if(arrChildren && arrChildren.length)
		{
			item.children = arrChildren;
		}
		if(attributes && Object.keys(attributes).length)
		{
			item.attributes = attributes;
		}
		var xml = this.__exportUtil.getXML(item);
		return xml;
	};
	
	//http://officeopenxml.com/WPstyles.php
	var Styles = function(docxRef,option)
	{
		this.__docDefaults = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Styles);
	Styles.prototype.constructor = Styles;
	NSDocxExport.prototype.Styles = Styles;
	
	Styles.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(option.default)
			{
				this.setDefaultStyle(option.default);
			}
			if(option.styles)
			{
				var arrStyle = option.styles;
				if(!this.util.isArray(arrStyle) && this.util.isObject(arrStyle))
				{
					arrStyle = [arrStyle];
				}
				var style = null;
				for(var count = 0;count < arrStyle.length;count++)
				{
					style = arrStyle[count];
					if(style)
					{
						this.addStyle(style);
					}
				}
			}
		}
	};
	
	Styles.prototype.setDefaultStyle = function(value)
	{
		if(value && value instanceof DefaultStyle)
		{
			this.__docDefaults = value;
		}
		else
		{
			!this.__docDefaults && (this.__docDefaults = new DefaultStyle(this.__docxRef,value));
		}
		return this.__docDefaults;
	};
	
	Styles.prototype.addStyle = function(option)
	{
		var style = new Style(this.__docxRef,option);
		this.__children.push(style);
		return style;
	};
	
	Styles.prototype.toXml = function()
	{
		if(this.__docDefaults)
		{
			this.__children.push(this.__docDefaults);
		}
		if(this.__children && this.__children.length)
		{
			var attributes = {
					"xmlns:mc": "http://schemas.openxmlformats.org/markup-compatibility/2006",
					"xmlns:r": "http://schemas.openxmlformats.org/officeDocument/2006/relationships",
		            "xmlns:w": "http://schemas.openxmlformats.org/wordprocessingml/2006/main",
		            "xmlns:w14": "http://schemas.microsoft.com/office/word/2010/wordml",
		            "xmlns:w15": "http://schemas.microsoft.com/office/word/2012/wordml",
		            "xmlns:Ignorable": "w14 w15"
	            };
			var xml = this.base.toXml.call(this,"w:styles",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPstyleDefaults.php
	var DefaultStyle = function(docxRef,option)
	{
		this.__paraDefault = null;
		this.__textDefault = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,DefaultStyle);
	DefaultStyle.prototype.constructor = DefaultStyle;
	NSDocxExport.prototype.DefaultStyle = DefaultStyle;
	
	DefaultStyle.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(option.paragraph)
			{
				this.setParaStyle(option.paragraph);
			}
			if(option.text)
			{
				this.setTextStyle(option.text);
			}
		}
	};
	
	DefaultStyle.prototype.setParaStyle = function(value)
	{
		if(value && value instanceof ParagraphFormat)
		{
			this.__paraDefault = value;
		}
		else
		{
			!this.__paraDefault && (this.__paraDefault = new ParagraphFormat(this.__docxRef,value));
		}
		return this.__paraDefault;
	};
	
	DefaultStyle.prototype.setTextStyle = function(value)
	{
		if(value && value instanceof RunFormat)
		{
			this.__textDefault = value;
		}
		else
		{
			!this.__textDefault && (this.__textDefault = new RunFormat(this.__docxRef,value));
		}
		return this.__textDefault;
	};
	
	DefaultStyle.prototype.toXml = function()
	{
		var childXml = null;
		if(this.__paraDefault)
		{
			childXml = this.__paraDefault.toXml();
			childXml = this.__exportUtil.getXML({
					name: "w:pPrDefault",
					children: [childXml],
				});
			this.__children.push(childXml);
		}
		if(this.__textDefault)
		{
			childXml = this.__textDefault.toXml();
			childXml = this.__exportUtil.getXML({
					name: "w:rPrDefault",
					children: [childXml],
				});
			this.__children.push(childXml);
		}
		
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:docDefaults");
			console.log(xml);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPstyle.php
	//http://officeopenxml.com/WPstyleGenProps.php
	var Style = function(docxRef,option)
	{
		this.__objAttr = {type: {value:null, method:"type" },
						  styleId: {value:null, method:"styleId" },
						  default: {value:null, method:"default" },
						  customStyle: {value:null, method:"customStyle" }
					};
		this.__objProp = {name: {value:null, method:"name"},
						  basedOn: {value:null, method:"basedOn"},
						  next: {value:null, method:"next"},
						  link: {value:null, method:"link"},
						  uiPriority: {value:null, method:"uiPriority"},
						  hidden: {value:null, method:"hidden",isEmpty: true},
						  locked: {value:null, method:"locked",isEmpty: true},
						  semiHidden: {value:null, method:"semiHidden",isEmpty: true},
						  unhideWhenUsed: {value:null, method:"unhideWhenUsed",isEmpty: true},
						  qFormat: {value:null, method:"quickFormat",isEmpty: true},
						  autoRedefine: {value:null, method:"autoRedefine",isEmpty: true},
						  pPr: {value:null, method:"paragraphFormat", className: "ParagraphFormat"},
						  rPr: {value:null, method:"runFormat", className: "RunFormat"},
						  tblPr: {value:null, method:"tableFormat", className: "TableFormat"},
					};
				
		this.base.init.call(this,docxRef);
		this.__exportUtil.addSingleValueFunctions(this,this.__objAttr,null,docxRef);
		var propCallback = function(value,paramItem,key,paramInstance)
		{
			if(paramItem.className)
			{
				if(value && value instanceof NSDocxExport.prototype[paramItem.className])
				{
					paramItem.value = value;
				}
				else
				{
					!paramItem.value && (paramItem.value = new NSDocxExport.prototype[paramItem.className](docxRef,value));
				}
			}
			else
			{
				paramItem.value = value;
			}
			return paramItem.value;
		};
		this.__exportUtil.addFunctions(this,this.__objProp,null,propCallback,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Style);
	Style.prototype.constructor = Style;
	NSDocxExport.prototype.Style = Style;
	
	Style.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(option.id)
			{
				this.styleId(option.id);
			}
			if(option.type)
			{
				this.type(option.type);
			}
			if(option.isDefault)
			{
				this.default(option.isDefault);
			}
			if(option.customStyle)
			{
				this.customStyle(option.customStyle);
			}
			if(option.name)
			{
				this.name(option.name);
			}
			if(option.basedOn)
			{
				this.basedOn(option.basedOn);
			}
			if(option.next)
			{
				this.next(option.next);
			}
			if(option.link)
			{
				this.link(option.link);
			}
			if(option.uiPriority)
			{
				this.uiPriority(option.uiPriority);
			}
			if(option.hidden)
			{
				this.hidden(option.hidden);
			}
			if(option.locked)
			{
				this.locked(option.locked);
			}
			if(option.semiHidden)
			{
				this.semiHidden(option.semiHidden);
			}
			if(option.unhideWhenUsed)
			{
				this.unhideWhenUsed(option.unhideWhenUsed);
			}
			if(option.quickFormat)
			{
				this.quickFormat(option.quickFormat);
			}
			if(option.autoRedefine)
			{
				this.autoRedefine(option.autoRedefine);
			}
			if(option.paragraph)
			{
				this.paragraphFormat(option.paragraph);
			}
			if(option.run)
			{
				this.runFormat(option.run);
			}
			if(option.table)
			{
				this.tableFormat(option.table);
			}
		}
	};
	
	Style.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objProp)
		{
			item = this.__objProp[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				if(item.className)
				{
					this.__children.push(item.value);
				}
				else if(item.isEmpty)
				{
					this.__children.push("<w:" + key + "/>");
				}
				else
				{
					this.__children.push(this.__exportUtil.getValXml(item.value,"w:" + key));
				}
			}
		}
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				attributes["w:" + key] = item.value;
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:style",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPheaders.php
	var Header = function(docxRef)
	{
		this.base.init.call(this,docxRef);
		this.__fileName = null;
		this.__idRef = null;
		var item = this.__docxRef.__addFile(this,"header","http://schemas.openxmlformats.org/officeDocument/2006/relationships/header","application/vnd.openxmlformats-officedocument.wordprocessingml.header+xml");
		if(item)
		{
			this.__fileName = item.fileName;
			this.__idRef = item.id;
		}
	};
	
	nsExtendPrototype(BaseElement,Header);
	Header.prototype.constructor = Header;
	NSDocxExport.prototype.Header = Header;
	
	Header.prototype.getRefID = function()
	{
		return this.__idRef;
	};
	
	Header.prototype.getFileName = function()
	{
		return this.__fileName;
	};
	
	Header.prototype.addParagraph = function(option)
	{
		 var para = new Paragraph(this.__docxRef,option);
		 this.__children.push(para);
		 return para;
	};
	
	Header.prototype.addTable = function(option)
	{
		 var table = new Table(this.__docxRef,option);
		 this.__children.push(table);
		 return table;
	};
	
	Header.prototype.toXml = function()
	{
		if(this.__children && this.__children.length)
		{
			var attributes = {
					"xmlns:wpc": "http://schemas.microsoft.com/office/word/2010/wordprocessingCanvas",
					"xmlns:mc": "http://schemas.openxmlformats.org/markup-compatibility/2006",
					"xmlns:o": "urn:schemas-microsoft-com:office:office",
					"xmlns:r": "http://schemas.openxmlformats.org/officeDocument/2006/relationships",
					"xmlns:m": "http://schemas.openxmlformats.org/officeDocument/2006/math",
					"xmlns:v": "urn:schemas-microsoft-com:vml",
					"xmlns:wp14": "http://schemas.microsoft.com/office/word/2010/wordprocessingDrawing",
					"xmlns:wp": "http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing",
					"xmlns:w10": "urn:schemas-microsoft-com:office:word",
					"xmlns:w": "http://schemas.openxmlformats.org/wordprocessingml/2006/main",
					"xmlns:w14": "http://schemas.microsoft.com/office/word/2010/wordml",
					"xmlns:w15": "http://schemas.microsoft.com/office/word/2012/wordml",
					"xmlns:wpg": "http://schemas.microsoft.com/office/word/2010/wordprocessingGroup",
					"xmlns:wpi": "http://schemas.microsoft.com/office/word/2010/wordprocessingInk",
					"xmlns:wne": "http://schemas.microsoft.com/office/word/2006/wordml",
					"xmlns:wps": "http://schemas.microsoft.com/office/word/2010/wordprocessingShape",
					"xmlns:cx": "http://schemas.microsoft.com/office/drawing/2014/chartex",
					"xmlns:cx1": "http://schemas.microsoft.com/office/drawing/2015/9/8/chartex",
					"xmlns:cx2": "http://schemas.microsoft.com/office/drawing/2015/10/21/chartex",
	                "xmlns:cx3": "http://schemas.microsoft.com/office/drawing/2016/5/9/chartex",
	                "xmlns:cx4": "http://schemas.microsoft.com/office/drawing/2016/5/10/chartex",
	                "xmlns:cx5": "http://schemas.microsoft.com/office/drawing/2016/5/11/chartex",
	                "xmlns:cx6": "http://schemas.microsoft.com/office/drawing/2016/5/12/chartex",
	                "xmlns:cx7": "http://schemas.microsoft.com/office/drawing/2016/5/13/chartex",
	                "xmlns:cx8": "http://schemas.microsoft.com/office/drawing/2016/5/14/chartex",
	                "xmlns:w16cid": "http://schemas.microsoft.com/office/word/2016/wordml/cid",
	                "xmlns:w16se": "http://schemas.microsoft.com/office/word/2015/wordml/symex",
	            };
			var xml = this.base.toXml.call(this,"w:hdr",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPfooters.php
	var Footer = function(docxRef)
	{
		this.base.init.call(this,docxRef);
		this.__fileName = null;
		this.__idRef = null;
		var item = this.__docxRef.__addFile(this,"footer","http://schemas.openxmlformats.org/officeDocument/2006/relationships/footer","application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml");
		if(item)
		{
			this.__fileName = item.fileName;
			this.__idRef = item.id;
		}
	};
	
	nsExtendPrototype(BaseElement,Footer);
	Footer.prototype.constructor = Footer;
	NSDocxExport.prototype.Footer = Footer;
	
	Footer.prototype.getRefID = function()
	{
		return this.__idRef;
	};
	
	Footer.prototype.getFileName = function()
	{
		return this.__fileName;
	};
	
	Footer.prototype.addParagraph = function(option)
	{
		 var para = new Paragraph(this.__docxRef,option);
		 this.__children.push(para);
		 return para;
	};
	
	Footer.prototype.addTable = function(option)
	{
		 var table = new Table(this.__docxRef,option);
		 this.__children.push(table);
		 return table;
	};
	
	Footer.prototype.toXml = function()
	{
		if(this.__children && this.__children.length)
		{
			var attributes = {
				"xmlns:wpc": "http://schemas.microsoft.com/office/word/2010/wordprocessingCanvas",
                "xmlns:mc": "http://schemas.openxmlformats.org/markup-compatibility/2006",
                "xmlns:o": "urn:schemas-microsoft-com:office:office",
                "xmlns:r": "http://schemas.openxmlformats.org/officeDocument/2006/relationships",
                "xmlns:m": "http://schemas.openxmlformats.org/officeDocument/2006/math",
                "xmlns:v": "urn:schemas-microsoft-com:vml",
                "xmlns:wp14": "http://schemas.microsoft.com/office/word/2010/wordprocessingDrawing",
                "xmlns:wp": "http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing",
                "xmlns:w10": "urn:schemas-microsoft-com:office:word",
                "xmlns:w": "http://schemas.openxmlformats.org/wordprocessingml/2006/main",
                "xmlns:w14": "http://schemas.microsoft.com/office/word/2010/wordml",
                "xmlns:w15": "http://schemas.microsoft.com/office/word/2012/wordml",
                "xmlns:wpg": "http://schemas.microsoft.com/office/word/2010/wordprocessingGroup",
                "xmlns:wpi": "http://schemas.microsoft.com/office/word/2010/wordprocessingInk",
                "xmlns:wne": "http://schemas.microsoft.com/office/word/2006/wordml",
                "xmlns:wps": "http://schemas.microsoft.com/office/word/2010/wordprocessingShape",
            }
			var xml = this.base.toXml.call(this,"w:ftr",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPnumbering.php
	var Numbering = function(docxRef,option)
	{
		this.__abstractNumID = 0;
		this.__numID = 0;
		this.__arrAbstractNum = [];
		this.__arrNum = [];
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Numbering);
	Numbering.prototype.constructor = Numbering;
	NSDocxExport.prototype.Numbering = Numbering;
	
	Numbering.prototype.setProperties = function(option)
	{
		if(option)
		{
			this.levelOverride(option);
		}
	};
	
	Numbering.prototype.__getAbstractNumID = function(fileRef)
	{
		var retID = this.__abstractNumID;
		this.__abstractNumID++;
		return retID;
	};
	
	Numbering.prototype.__getNumID = function(fileRef)
	{
		return ++this.__numID; 
	};
	
	Numbering.prototype.addAbstractNumber = function(value)
	{
		var abstractNumber = null;
		if(value && value instanceof AbstractNumbering) 
		{
			abstractNumber = value
		}
		else
		{
			abstractNumber = new AbstractNumbering(this.__docxRef,this,value);
		}
		this.__arrAbstractNum.push(abstractNumber);
		var number = this.addNumber(null,abstractNumber);
		return {abstractNumber: abstractNumber,number: number};
	};
	
	Numbering.prototype.addNumber = function(value,abstractNumber)
	{
		var retValue = null;
		if(value && value instanceof ConcreteNumbering) 
		{
			retValue = value
		}
		else
		{
			retValue = new ConcreteNumbering(this.__docxRef,this,abstractNumber,value);
		}
		this.__arrNum.push(retValue);
		return retValue;
	};
	
	Numbering.prototype.toXml = function()
	{
		if(this.__children && this.__children.length)
		{
			var attributes = {
					"xmlns:wpc": "http://schemas.microsoft.com/office/word/2010/wordprocessingCanvas",
					"xmlns:mc": "http://schemas.openxmlformats.org/markup-compatibility/2006",
		            "xmlns:o": "urn:schemas-microsoft-com:office:office",
		            "xmlns:r": "http://schemas.openxmlformats.org/officeDocument/2006/relationships",
		            "xmlns:m": "http://schemas.openxmlformats.org/officeDocument/2006/math",
		            "xmlns:v": "urn:schemas-microsoft-com:vml",
		            "xmlns:wp14": "http://schemas.microsoft.com/office/word/2010/wordprocessingDrawing",
		            "xmlns:wp": "http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing",
		            "xmlns:w10": "urn:schemas-microsoft-com:office:word",
		            "xmlns:w": "http://schemas.openxmlformats.org/wordprocessingml/2006/main",
		            "xmlns:w14": "http://schemas.microsoft.com/office/word/2010/wordml",
		            "xmlns:w15": "http://schemas.microsoft.com/office/word/2012/wordml",
		            "xmlns:wpg": "http://schemas.microsoft.com/office/word/2010/wordprocessingGroup",
		            "xmlns:wpi": "http://schemas.microsoft.com/office/word/2010/wordprocessingInk",
		            "xmlns:wne": "http://schemas.microsoft.com/office/word/2006/wordml",
		            "xmlns:wps": "http://schemas.microsoft.com/office/word/2010/wordprocessingShape",
		            "xmlns:Ignorable": "w14 w15 wp14",
            }
			var xml = this.base.toXml.call(this,"w:numbering",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPnumbering.php
	var ConcreteNumbering = function(docxRef,parent,abstractNum,option)
	{
		this.__lvlOverride = null;
		this.base.init.call(this,docxRef);
		this.__parent = parent;
		this.__abstractNum = abstractNum;
		this.__id = this.__parent.__getNumID(this);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,ConcreteNumbering);
	ConcreteNumbering.prototype.constructor = ConcreteNumbering;
	NSDocxExport.prototype.ConcreteNumbering = ConcreteNumbering;
	
	ConcreteNumbering.prototype.setProperties = function(option)
	{
		if(option)
		{
			this.levelOverride(option);
		}
	};
	
	ConcreteNumbering.prototype.levelOverride = function(value)
	{
		if(value && value instanceof NumberingLevel) 
		{
			this.__lvlOverride = value
		}
		else
		{
			!this.__lvlOverride && (this.__lvlOverride = new LevelOverride(this.__docxRef,value));
		}
		return this.__lvlOverride;
	};
	
	ConcreteNumbering.prototype.toXml = function()
	{
		var attributes = {};
		attributes["w:numId"] = this.__id;
		if(this.__abstractNum)
		{
			this.__children.push("<w:abstractNumId w:val=\"" + this.__abstractNum.getID() + "\"/>");
		}
		if(this.__lvlOverride)
		{
			this.__children.push(this.__lvlOverride);
		}
		var xml = this.base.toXml.call(this,"w:num",attributes);
		return xml;
	};
	
	//http://officeopenxml.com/WPnumberingOverride.php
	var LevelOverride = function(docxRef,option)
	{
		this.__ilvl = null;
		this.__lvl = null;
		this.__startOverride = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,LevelOverride);
	LevelOverride.prototype.constructor = LevelOverride;
	NSDocxExport.prototype.LevelOverride = LevelOverride;
	
	LevelOverride.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(this.util.isUndefinedOrNull(option.numberingLevel))
			{
				this.numberingLevel(option.numberingLevel);
			}
			if(this.util.isUndefinedOrNull(option.level))
			{
				this.level(option.level);
			}
			if(this.util.isUndefinedOrNull(option.startOverride))
			{
				this.startOverride(option.startOverride);
			}
		}
	};
	
	LevelOverride.prototype.numberingLevel = function(value)
	{
		this.__ilvl = value;
		return this.__ilvl;
	};
	
	LevelOverride.prototype.level = function(value)
	{
		if(value && value instanceof AbstractNumbering) 
		{
			this.__lvl = value
		}
		else
		{
			!this.__lvl && (this.__lvl = new AbstractNumbering(this.__docxRef,value));
		}
		return this.__lvl;
	};
	
	LevelOverride.prototype.startOverride = function(value)
	{
		this.__startOverride = value;
		return this.__startOverride;
	};
	
	LevelOverride.prototype.toXml = function()
	{
		var attributes = {};
		if(this.util.isUndefinedOrNull(this.__ilvl))
		{
			attributes["w:ilvl"] = this.__ilvl;
		}
		if(this.__lvl)
		{
			this.__children.push(this.__lvl);
		}
		if(this.__startOverride)
		{
			this.__children.push("<w:startOverride w:val=\"" + this.__startOverride + "\"/>");
		}
		var xml = this.base.toXml.call(this,"w:lvlOverride",attributes);
		return xml;
	};
	
	
	
	
	//http://officeopenxml.com/WPnumberingAbstractNum.php
	var AbstractNumbering = function(docxRef,parent,option)
	{
		this.__objAttr = {abstractNumId: {value:null, method:"id",tag:"w:abstractNumId" },
				  		  restartNumberingAfterBreak: {value:null, method:"restartNumberingAfterBreak", tag:"w15:restartNumberingAfterBreak"},
		};
		this.__objProp = {multiLevelType: {value:null, method:"multiLevelType"},
						  name: {value:null, method:"name"},
						  numStyleLink: {value:null, method:"numStyleLink"},
						  styleLink: {value:null, method:"styleLink"},
		};
		this.__arrLevel = [];
		this.base.init.call(this,docxRef);
		this.__exportUtil.addSingleValueFunctions(this,this.__objAttr,null,docxRef);
		this.__parent = parent;
		this.__id = this.__parent.__getAbstractNumID(this);
		var propCallback = function(value,paramItem,key,paramInstance)
		{
			paramItem.value = value;
			return paramItem.value;
		};
		this.__exportUtil.addFunctions(this,this.__objProp,null,propCallback,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,AbstractNumbering);
	AbstractNumbering.prototype.constructor = AbstractNumbering;
	NSDocxExport.prototype.AbstractNumbering = AbstractNumbering;
	
	AbstractNumbering.prototype.setProperties = function(option)
	{
		this.abstractNumId(this.__id);
		option = option || {};
		!this.util.isUndefinedOrNull(option.restartNumberingAfterBreak) ? this.restartNumberingAfterBreak(option.restartNumberingAfterBreak) : this.restartNumberingAfterBreak(0);
		!this.util.isUndefinedOrNull(option.multiLevelType) ? this.multiLevelType(option.multiLevelType) : this.multiLevelType("hybridMultilevel");
		if(option.name)
		{
			this.name(option.name);
		}
		if(option.numStyleLink)
		{
			this.numStyleLink(option.numStyleLink);
		}
		if(option.styleLink)
		{
			this.styleLink(option.styleLink);
		}
		if(option.levels && option.levels.length)
		{
			for(var count = 0;count < option.levels.length;count++)
			{
				this.addLevel(option.levels[count]);
			}
		}
	};
	
	AbstractNumbering.prototype.getID = function()
	{
		return this.__id;
	};
	
	AbstractNumbering.prototype.addLevel = function(value)
	{
		var level = null;
		if(value && value instanceof NumberingLevel) 
		{
			level = value
		}
		else
		{
			level = new NumberingLevel(this.__docxRef,value);
		}
		this.__arrLevel.push(level);
		return level;
	};
	
	AbstractNumbering.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				if(item.tag)
				{
					attributes[item.tag] = item.value;
				}
				else
				{
					attributes["w:" + key] = item.value;
				}
			}
		}
		for(key in this.__objProp)
		{
			item = this.__objProp[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				this.__children.push(this.__exportUtil.getValXml(item.value,"w:" + key));
			}
		}
		if(this.__arrLevel && this.__arrLevel.length)
		{
			for(var count = 0;count < this.__arrLevel.length;count++)
			{
				this.__children.push(this.__arrLevel[count]);
			}
		}
		
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:lvl",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPnumberingLvl.php
	var NumberingLevel = function(docxRef,option)
	{
		this.__objAttr = {ilvl: {value:null, method:"level",tag:"w:ilvl" },
						  tentative: {value:null, method:"tentative", tag:"w15:tentative", isBoolean: true },
		};
		this.__objProp = {start: {value:null, method:"start",attr:"w:val" },
						  numFmt: {value:null, method:"numberFormat",attr:"w:val"},
						  lvlText: {value:null, method:"levelText",attr:"w:val"},
						  lvlJc: {value:null, method:"levelJc",attr:"w:val"},
						  pPr: {value:null, method:"paragraphFormat", className: "ParagraphFormat"},
						  rPr: {value:null, method:"runFormat", className: "RunFormat"},
		};
		
		this.base.init.call(this,docxRef);
		this.__exportUtil.addSingleValueFunctions(this,this.__objAttr,null,docxRef);
		var propCallback = function(value,paramItem,key,paramInstance)
		{
			if(paramItem.className)
			{
				if(value && value instanceof NSDocxExport.prototype[paramItem.className])
				{
					paramItem.value = value;
				}
				else
				{
					!paramItem.value && (paramItem.value = new NSDocxExport.prototype[paramItem.className](docxRef,value));
				}
			}
			else
			{
				paramItem.value = value;
			}
			return paramItem.value;
		};
		this.__exportUtil.addFunctions(this,this.__objProp,null,propCallback,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,NumberingLevel);
	NumberingLevel.prototype.constructor = NumberingLevel;
	NSDocxExport.prototype.NumberingLevel = NumberingLevel;
	
	NumberingLevel.prototype.setProperties = function(option)
	{
		if(option)
		{
			this.level(option.level);
			!this.util.isUndefinedOrNull(option.tentative) ? this.tentative(option.tentative) : this.tentative(true);
			!this.util.isUndefinedOrNull(option.start) ? this.start(option.start) : this.start(1);
			if(option.format) 
			{
	            this.numberFormat(option.format);
	        }
	        if(option.text) 
	        {
	            this.levelText(option.text);
	        }
	        !this.util.isUndefinedOrNull(option.alignment) ? this.levelJc(option.alignment) : this.levelJc("start");
	        if(option.style)
	        {
	        	if(option.style.paragraph)
				{
					this.paragraphFormat(option.paragraph);
				}
				if(option.run)
				{
					this.runFormat(option.run);
				}
	        }
		}
	};
	
	NumberingLevel.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objProp)
		{
			item = this.__objProp[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				if(item.className)
				{
					this.__children.push(item.value);
				}
				else
				{
					this.__children.push(this.__exportUtil.getValXml(item.value,"w:" + key));
				}
			}
		}
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				if(item.tag)
				{
					attributes[item.tag] = (item.isBoolean) ? (Boolean.parse(item.value) ? 1 : 0) : item.value;
				}
				else
				{
					attributes["w:" + key] = item.value;
				}
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:lvl",attributes);
			return xml;
		}
		return null;
	};
	
	
	//http://officeopenxml.com/WPtable.php
	var Table = function(docxRef,option)
	{
		this.__format = null;
		this.__tblGrid = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Table);
	Table.prototype.constructor = Table;
	NSDocxExport.prototype.Table = Table;
	
	Table.prototype.setProperties = function(option)
	{
		option = option || {};
		this.format(option);
	};
	
	Table.prototype.format = function(value)
	{
		if(value && value instanceof TableFormat) 
		{
			this.__format = value
		}
		else
		{
			!this.__format && (this.__format = new TableFormat(this.__docxRef,value));
		}
		return this.__format;
	};
	
	Table.prototype.grid = function(value)
	{
		if(value && value instanceof TableGrid) 
		{
			this.__tblGrid = value
		}
		else
		{
			!this.__tblGrid && (this.__tblGrid = new TableGrid(this.__docxRef,value));
		}
		return this.__tblGrid;
	};
	
	Table.prototype.addRow = function()
	{
		var row = new TableRow(this.__docxRef);
	    this.__children.push(row);
	    return row;
	};
	
	Table.prototype.toXml = function()
	{
		if(this.__tblGrid)
	    {	
	    	this.__children.unshift(this.__tblGrid);
	    }
	    if(this.__format)
	    {	
	    	this.__children.unshift(this.__format);
	    }
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tbl");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableCell.php
	var TableCell = function(docxRef)
	{
		this.__format = null;
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,TableCell);
	TableCell.prototype.constructor = TableCell;
	NSDocxExport.prototype.TableCell = TableCell;
	
	TableCell.prototype.format = function(value)
	{
		if(value && value instanceof TableCellFormat) 
		{
			this.__format = value
		}
		else
		{
			!this.__format && (this.__format = new TableCellFormat(this.__docxRef));
		}
		return this.__format;
	};
	
	TableCell.prototype.addParagraph = function(option)
	{
		 var para = new Paragraph(this.__docxRef,option);
		 this.__children.push(para);
		 return para;
	};
	
	TableCell.prototype.addTable = function(option)
	{
		 var table = new Table(this.__docxRef,option);
		 this.__children.push(table);
		 return table;
	};
	
	TableCell.prototype.toXml = function()
	{
		if(this.__format)
		{
			this.__children.unshift(this.__format);
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tc");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableCellProperties.php
	var TableCellFormat = function(docxRef)
	{
		this.__noWrap = false;
		this.__objProp = {gridSpan: null,shading: null,tcBorders: null,tcFitText: null,tcMar: null,tcW: null,vAlign: null,vMerge: null};
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,TableCellFormat);
	TableCellFormat.prototype.constructor = TableCellFormat;
	NSDocxExport.prototype.TableCellFormat = TableCellFormat;
	
	TableCellFormat.prototype.gridSpan = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp.gridSpan = this.__exportUtil.getXML({
				name: "w:gridSpan",
				attributes: {"w:val": value},
			});
		}
	};
	
	TableCellFormat.prototype.noWrap = function(value)
	{
		this.__noWrap = value;
	};
	
	TableCellFormat.prototype.shading = function(value)
	{
		if(value && value instanceof Shading)
		{
			this.__objProp.shading = value;
		}
		else
		{
			!this.__objProp.shading && (this.__objProp.shading = new Shading(this.__docxRef,value));
		}
		return this.__objProp.shading;
	};
	
	TableCellFormat.prototype.fitText = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp.tcFitText = this.__exportUtil.getXML({
				name: "w:tcFitText",
				attributes: {"w:val": value},
			});
		}
		return this.__objProp.tcFitText;
	};
	
	TableCellFormat.prototype.margins = function(value)
	{
		if(value && value instanceof TableCellMargins)
		{
			this.__objProp.tcMar = value;
		}
		else
		{
			!this.__objProp.tcMar && (this.__objProp.tcMar = new TableCellMargins(this.__docxRef));
		}
		return this.__objProp.tcMar;
	};
	
	TableCellFormat.prototype.width = function(width,unitType)
	{
		if(!this.util.isUndefinedOrNull(width))
		{
			this.__objProp.tcW = this.__exportUtil.getXML({
				name: "w:tcW",
				attributes: {"w:type": unitType || "","w:w": width}
			});
		}
		return this.__objProp.tcW;
	};
	
	TableCellFormat.prototype.verticalAlign = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp.vAlign = this.__exportUtil.getXML({
				name: "w:vAlign",
				attributes: {"w:val": value}
			});
		}
		return this.__objProp.vAlign;
	};
	
	//value can be continue,restart 
	TableCellFormat.prototype.verticalMerge = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp.vMerge = this.__exportUtil.getXML({
				name: "w:vMerge",
				attributes: {"w:val": value}
			});
		}
		return this.__objProp.vMerge;
	};
	
	TableCellFormat.prototype.toXml = function()
	{
		for(var key in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[key]))
			{
				this.__children.push(this.__objProp[key]);
			}
		}
		if(this.__noWrap)
		{
			this.__children.push("<w:noWrap/>");
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tcPr");
			return xml;
		}
	};
	
	//http://officeopenxml.com/WPtableCellProperties-Margins.php
	var TableCellMargins = function(docxRef,option)
	{
		//{val: null,sz: null,space: null,color: null}
		//this.__objProp = {top: null,start: null,bottom: null,end: null};
		//old doc version uses left and right rather than start and end
		this.__objProp = {top: null,left: null,bottom: null,right: null};
		this.base.init.call(this,docxRef);
		if(!this.top)
		{
			option = option || {};
			var self = this;
			for(var key in this.__objProp)
			{
				item = this.__objProp[key];
				(function(item,key)
				{
					self[key] = function(width,type)
					{
						return self.__setProp(key,width,type);
					};
					if(option[key])
					{
						var paramItem = option[key];
						self[key](paramItem.width,paramItem.type);
					}
				})(item,key)
				
			}
		}
	};
	
	nsExtendPrototype(BaseElement,TableCellMargins);
	TableCellMargins.prototype.constructor = TableCellMargins;
	NSDocxExport.prototype.TableCellMargins = TableCellMargins;
	
	TableCellMargins.prototype.setAll = function(color,width,type) 
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this[key](width,type);
			}
		}
	};
	
	TableCellMargins.prototype.__setProp = function(key,width,type)
	{
		if(!this.util.isUndefinedOrNull(width))
		{
			var item = {w: width,type: type || "dxa"};
			this.__objProp[key] = item;
		}
		return this.__objProp[key];
	};
	
	TableCellMargins.prototype.__xmlProp = function(key,item)
	{
		var attributes = {};
		for(var paramKey in item)
		{
			if(!this.util.isUndefinedOrNull(item[paramKey]))
			{
				attributes["w:" + paramKey] = item[paramKey];
			}
		}
		var xml = this.__exportUtil.getXML({
			name: "w:" + key,
			attributes: attributes,
		});
		return xml;
	};
	
	TableCellMargins.prototype.toXml = function()
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this.__children.push(this.__xmlProp(key,item));
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tcMar");
			return xml;
		}
		return null;
	};
	
	
	//http://officeopenxml.com/WPtableRow.php
	var TableRow = function(docxRef)
	{
		this.__rowProp = null;
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,TableRow);
	TableRow.prototype.constructor = TableRow;
	NSDocxExport.prototype.TableRow = TableRow;
	
	TableRow.prototype.format = function(value)
	{
		/*if(value && value instanceof TableRowFormat) 
		{
			this.__rowProp = value
		}
		else
		{
			!this.__rowProp && (this.__rowProp = new TableRowFormat(this.__docxRef));
		}
		return this.__rowProp;*/
	};
	
	TableRow.prototype.addCell = function()
	{
		 var cell = new TableCell(this.__docxRef);
		 this.__children.push(cell);
		 return cell;
	};
	
	TableRow.prototype.toXml = function()
	{
		if(this.__rowProp)
		{
			this.__children.unshift(this.__rowProp);
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tr");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableGrid.php
	var TableGrid = function(docxRef)
	{
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,TableGrid);
	TableGrid.prototype.constructor = TableGrid;
	NSDocxExport.prototype.TableGrid = TableGrid;
	
	TableGrid.prototype.addColumn = function(value)
	{
		 var column = new TableGridColumn(this.__docxRef);
		 this.__children.push(column);
		 return column;
	};
	
	TableGrid.prototype.toXml = function()
	{
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tblGrid");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableGrid.php
	var TableGridColumn = function(docxRef,width)
	{
		this.__objAttr = {w: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(width) && this.width(width);
	};
	
	nsExtendPrototype(BaseElement,TableGridColumn);
	TableGridColumn.prototype.constructor = TableGridColumn;
	NSDocxExport.prototype.TableGridColumn = TableGridColumn;
	
	TableGridColumn.prototype.width = function(value)
	{
		return this.__setAttr("w",value);
	};
	
	TableGridColumn.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	TableGridColumn.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:gridCol",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableProperties.php
	var TableFormat = function(docxRef,option)
	{
		this.__objProp = {jc:{value: null,method:"alignment",className: "TableAlignment"},
						  shd:{value: null,method:"shading",className: "Shading"},
						  tblBorders:{value: null,method:"borders",className: "TableBorders"},
						  //tblCaption:{value: null,method:"caption",className: "TableCaption"},
						  tblCellMar:{value: null,method:"cellMargin",className: "TableCellMarginsDefault"},
						  //tblCellSpacing:{value: null,method:"cellSpacing",className: "TableCellSpacing"},
						  //tblInd:{value: null,method:"indent",className: "TableIndent"},
						  tblLayout:{value: null,method:"layout",className: "TableLayout"},
						  //tblLook:{value: null,method:"look",className: "TableLook"},
						  //tblOverlap:{value: null,method:"overlap",className: "TableOverlap"},
						  //tblpPr:{value: null,method:"ppr",className: "TablePPr"},
						  //tblStyle:{value: null,method:"style",className: "TableStyle"},
						  //tblStyleColBandSize:{value: null,method:"styleColBandSize",className: "TableStyleColBandSize"},
						  //tblStyleRowBandSize:{value: null,method:"styleRowBandSize",className: "TableStyleRowBandSize"},
						  tblW:{value: null,method:"width",className: "TableWidth"},
						  tblStyle:{value: null, method: "styleID"},
						 };
		this.base.init.call(this,docxRef);
		this.__exportUtil.addFunctions(this,"__objProp",option,null,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,TableFormat);
	TableFormat.prototype.constructor = TableFormat;
	NSDocxExport.prototype.TableFormat = TableFormat;
	
	TableFormat.prototype.setProperties = function(option)
	{
		option = option || {};
		if(option.alignment) 
		{
            this.alignment(option.alignment);
        }
		if(option.shading) 
		{
            this.shading(option.shading);
        }
		if(option.borders) 
		{
            this.borders(option.borders);
        }
		if(option.cellMargin)
		{
			this.cellMargin(option.cellMargin);
		}
        if(option.layout) 
        {
            this.layout(option.layout);
        }
        if(option.width) 
        {
        	this.width(option.width);
        }
        else 
        {
            this.width(100);
        }
        if (option.styleID) 
        {
            this.styleID(option.styleID);
        }
	};
	
	TableFormat.prototype.styleID = function(value)
	{
		if(value)
		{
			this.__objProp.tblStyle.value = "<w:tblStyle w:val=\"" + value + "\"/>"
		}
		return this.__objProp.tblStyle.value;
	};
	
	TableFormat.prototype.toXml = function()
	{
		var item = null;
		for(var paramKey in this.__objProp)
		{
			item = this.__objProp[paramKey]
			if(!this.util.isUndefinedOrNull(item.value))
			{
				if(item)
				this.__children.push(item.value);
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tblPr");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableAlignment.php
	var TableAlignment = function(docxRef,value)
	{
		this.__value = null;
		this.base.init.call(this,docxRef);
		this.value(value);
	};
	
	nsExtendPrototype(BaseElement,TableAlignment);
	TableAlignment.prototype.constructor = TableAlignment;
	NSDocxExport.prototype.TableAlignment = TableAlignment;
	
	TableAlignment.prototype.value = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__value = value;
		}
		return this.__value;
	};
	
	TableAlignment.prototype.toXml = function()
	{
		if(!this.util.isUndefinedOrNull(this.__value))
		{
			var xml = this.base.toXml.call(this,"w:tblPr",{"w:val": this.__value});
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableBorders.php
	var TableBorders = function(docxRef,option)
	{
		//some older versions of word still uses left and right rather than start and end 
		//this.__objProp = {top: null,start: null,bottom: null,end: null,insideH: null,insideV: null};
		this.__objProp = {top: null,left: null,bottom: null,right: null,insideH: null,insideV: null};
		this.base.init.call(this,docxRef);
		if(!this.top)
		{
			option = option || {};
			var self = this;
			for(var key in this.__objProp)
			{
				item = this.__objProp[key];
				(function(item,key)
				{
					self[key] = function(color,shadow,space,size,value)
					{
						return self.__setProp(key,color,shadow,space,size,value);
					};
					if(option[key])
					{
						var paramItem = option[key];
						self[key](paramItem.color,paramItem.shadow,paramItem.space,paramItem.size,paramItem.value);
					}
				})(item,key)
				
			}
		}
		this.setDefault();
	};
	
	nsExtendPrototype(BaseElement,TableBorders);
	TableBorders.prototype.constructor = TableBorders;
	NSDocxExport.prototype.TableBorders = TableBorders;
	
	TableBorders.prototype.setDefault = function(color,shadow,space,size,value) 
	{
		this.setAll();
		for(var key in this.__objProp)
		{
			if(!this.__objProp[key])
			{
				this[key]("auto",null,0,4,"single");
			}
		}
	};
	
	TableBorders.prototype.setOutside = function(color,shadow,space,size,value) 
	{
	    this.top(color,shadow,space,size,value);
	    this.left(color,shadow,space,size,value);
	    //this.start(color,shadow,space,size,value);
	    //this.end(color,shadow,space,size,value);
	    this.right(color,shadow,space,size,value);
	    this.bottom(color,shadow,space,size,value);
	};

	TableBorders.prototype.setInside = function(color,shadow,space,size,value) 
	{
	    this.insideH(color,shadow,space,size,value);
	    this.insideV(color,shadow,space,size,value);
	};

	TableBorders.prototype.setAll = function(color,shadow,space,size,value) 
	{
		this.setInside(color,shadow,space,size,value);
	    this.setOutside(color,shadow,space,size,value);
	};
	
	TableBorders.prototype.__setProp = function(key,color,shadow,space,size,value)
	{
		if(!this.util.isUndefinedOrNull(color) || !this.util.isUndefinedOrNull(shadow) || !this.util.isUndefinedOrNull(space) || !this.util.isUndefinedOrNull(size) || !this.util.isUndefinedOrNull(value))
		{
			var item = {color: color,shadow: shadow,space: space,sz: size,val: value};
			this.__objProp[key] = item;
		}
		return this.__objProp[key];
	};
	
	TableBorders.prototype.__xmlProp = function(key,item)
	{
		var attributes = {};
		for(var paramKey in item)
		{
			if(!this.util.isUndefinedOrNull(item[paramKey]))
			{
				attributes["w:" + paramKey] = item[paramKey];
			}
		}
		var xml = this.__exportUtil.getXML({
			name: "w:" + key,
			attributes: attributes,
		});
		return xml;
	};
	
	TableBorders.prototype.toXml = function()
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this.__children.push(this.__xmlProp(key,item));
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tblBorders");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableCellMargins.php
	var TableCellMarginsDefault = function(docxRef,option)
	{
		//this.__objProp = {top: null,start: null,bottom: null,end: null};
		//old doc version uses left and right rather than start and end
		this.__objProp = {top: null,left: null,bottom: null,right: null};
		this.base.init.call(this,docxRef);
		if(!this.top)
		{
			option = option || {};
			var self = this;
			for(var key in this.__objProp)
			{
				item = this.__objProp[key];
				(function(item,key)
				{
					self[key] = function(width,type)
					{
						return self.__setProp(key,width,type);
					};
					if(option[key])
					{
						var paramItem = option[key];
						self[key](paramItem.width,paramItem.type);
					}
				})(item,key)
				
			}
		}
	};
	
	nsExtendPrototype(BaseElement,TableCellMarginsDefault);
	TableCellMarginsDefault.prototype.constructor = TableCellMarginsDefault;
	NSDocxExport.prototype.TableCellMarginsDefault = TableCellMarginsDefault;
	
	TableCellMarginsDefault.prototype.setAll = function(color,width,type) 
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this[key](width,type);
			}
		}
	};
	
	TableCellMarginsDefault.prototype.__setProp = function(key,width,type)
	{
		if(!this.util.isUndefinedOrNull(width))
		{
			var item = {w: width,type: type || "dxa"};
			this.__objProp[key] = item;
		}
		return this.__objProp[key];
	};
	
	TableCellMarginsDefault.prototype.__xmlProp = function(key,item)
	{
		var attributes = {};
		for(var paramKey in item)
		{
			if(!this.util.isUndefinedOrNull(item[paramKey]))
			{
				attributes["w:" + paramKey] = item[paramKey];
			}
		}
		var xml = this.__exportUtil.getXML({
			name: "w:" + key,
			attributes: attributes,
		});
		return xml;
	};
	
	TableCellMarginsDefault.prototype.toXml = function()
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this.__children.push(this.__xmlProp(key,item));
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:tblCellMar");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableCellMargins.php
	var TableLayout = function(docxRef,type)
	{
		this.__type = null;
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,TableLayout);
	TableLayout.prototype.constructor = TableLayout;
	NSDocxExport.prototype.TableLayout = TableLayout;
	
	TableLayout.prototype.type = function(type)
	{
		this.__type = type;
	};
	
	TableLayout.prototype.toXml = function()
	{
		if(this.__type && this.__type.length)
		{
			var xml = this.base.toXml.call(this,"w:tblLayout",{"w:type": this.__type});
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtableWidth.php
	var TableWidth = function(docxRef,width,type)
	{
		this.__objAttr = {type: null,w: null};
		this.base.init.call(this,docxRef);
		var option = this.util.isObject(width) ? width : {type: type,width: width};
		this.type(option.type || "auto");
		!this.util.isUndefinedOrNull(option.width) && this.width(option.width);
	};
	
	nsExtendPrototype(BaseElement,TableWidth);
	TableWidth.prototype.constructor = TableWidth;
	NSDocxExport.prototype.TableWidth = TableWidth;
	
	TableWidth.prototype.type = function(value)
	{
		return this.__setAttr("type",value);
	};
	
	TableWidth.prototype.width = function(value)
	{
		return this.__setAttr("w",value);
	};
	
	TableWidth.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	TableWidth.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:tblW",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsection.php
	var Section = function(docxRef,option)
	{
		//cols,lnNumType,pgBorders,pgMar,pgNumType,pgSz,type
		this.__objProp = {cols:{value: null,method:"cols",className: "SectionColumns"},
						  lnNumType:{value: null,method:"lnNumType",className: "LineNumbers"},
						  pgBorders:{value: null,method:"pgBorders",className: "SectionBorder"},
						  pgMar:{value: null,method:"pgMar",className: "PageMargins"},
						  pgNumType:{value: null,method:"pgNumType",className: "PageNumbers"},
						  pgSz:{value: null,method:"pgSz",className: "PageSize"},
						  type:{value: null,method:"type",className: "SectionType"},
						  vAlign:{value: null,method:"type",className: "SectionVAlign"},
						 };
		this.__default = {header: null,footer: null};
		this.base.init.call(this,docxRef);
		this.__exportUtil.addFunctions(this,"__objProp",option,null,docxRef);
		this.__setDefaultValues();
	};
	
	nsExtendPrototype(BaseElement,Section);
	Section.prototype.constructor = Section;
	NSDocxExport.prototype.Section = Section;
	
	Section.prototype.__setDefaultValues = function()
	{
		if(!this.__objProp.cols.value)
		{
			var cols = this.cols();
			cols.num(1);
			cols.space(708);
		}
		/*if(!this.__objProp.pgNumType.value)
		{
			var pgNumType = this.pgNumType();
			pgNumType.fmt("decimal");
			pgNumType.start(1);
		}*/
	};
	
	Section.prototype.addHeader = function(type)
	{
		var header = new Header(this.__docxRef);
		var refID = header.getRefID();
	    if((!type || type.toLowerCase() == "default") && this.__setDefault("header",header))
	    {
	    	type = "default";
	    }
	    this.__children.push("<w:headerReference w:type=\"" + type + "\" r:id=\"" + refID + "\"/>");
	    return header;
	};
	
	Section.prototype.addFooter = function(type)
	{
		var footer = new Footer(this.__docxRef);
	    var refID = footer.getRefID();
	    if((!type || type.toLowerCase() == "default") && this.__setDefault("footer",footer))
	    {
	    	type = "default";
	    }
	    this.__children.push("<w:footerReference w:type=\"" + type + "\" r:id=\"" + refID + "\"/>");
	    return footer;
	};
	
	Section.prototype.addParagraph = function(option)
	{
		var paragraph = new Paragraph(this.__docxRef,option);
	    this.__children.push(paragraph);
	    return paragraph;
	};
	
	Section.prototype.addTable = function(option)
	{
		var table = new Table(this.__docxRef,option);
	    this.__children.push(table);
	    return table;
	};
	
	Section.prototype.__setDefault = function(key,value)
	{
		if(key && value && !this.__default[key])
		{
			this.__default[key] = value;
			return true;
		}
		return false;
	};
	
	Section.prototype.toXml = function()
	{
		var item = null;
		for(var paramKey in this.__objProp)
		{
			item = this.__objProp[paramKey]
			if(!this.util.isUndefinedOrNull(item.value))
			{
				this.__children.push(item.value);
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:sectPr");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsection.php (in Elements section)
	var SectionType = function(docxRef,value)
	{
		this.__objAttr = {val: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(value) && this.value(value);
	};
	
	nsExtendPrototype(BaseElement,SectionType);
	SectionType.prototype.constructor = SectionType;
	NSDocxExport.prototype.SectionType = SectionType;
	
	SectionType.prototype.value = function(value)
	{
		return this.__setAttr("val",value);
	};
	
	SectionType.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	SectionType.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:type",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsection.php (in Elements section)
	var SectionVAlign = function(docxRef,value)
	{
		this.__objAttr = {val: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(value) && this.value(value);
	};
	
	nsExtendPrototype(BaseElement,SectionVAlign);
	SectionVAlign.prototype.constructor = SectionVAlign;
	NSDocxExport.prototype.SectionVAlign = SectionVAlign;
	
	SectionVAlign.prototype.value = function(value)
	{
		return this.__setAttr("val",value);
	};
	
	SectionVAlign.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	SectionVAlign.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:vAlign",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsectionCols.php
	var SectionColumns = function(docxRef,equalWidth,num,sep,space)
	{
		this.__objProp = {equalWidth: null,num: null,sep: null,space: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(equalWidth) && this.equalWidth(equalWidth);
		!this.util.isUndefinedOrNull(num) && this.num(num);
		!this.util.isUndefinedOrNull(sep) && this.sep(sep);
		!this.util.isUndefinedOrNull(space) && this.space(space);
	};
	
	nsExtendPrototype(BaseElement,SectionColumns);
	SectionColumns.prototype.constructor = SectionColumns;
	NSDocxExport.prototype.SectionColumns = SectionColumns;
	
	SectionColumns.prototype.equalWidth = function(value)
	{
		return this.__setProp("equalWidth",value);
	};
	
	SectionColumns.prototype.num = function(value)
	{
		return this.__setProp("num",value);
	};
	
	SectionColumns.prototype.sep = function(value)
	{
		return this.__setProp("sep",value);
	};
	
	SectionColumns.prototype.space = function(value)
	{
		return this.__setProp("space",value);
	};
	
	SectionColumns.prototype.addColumn = function(width,space)
	{
		var item = null;
		if(!this.util.isUndefinedOrNull(width))
		{
			item = {width: width,space: space};
			this.__children.push(item);
		}
		return item;
	};
	
	SectionColumns.prototype.__setProp = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp[key] = value;
		}
		return this.__objProp[key];
	};
	
	SectionColumns.prototype.toXml = function()
	{
		var attributes = {};
		for(var paramKey in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[paramKey]))
			{
				attributes["w:" + paramKey] = this.__objProp[paramKey];
			}
		}
		var arrChildren = [];
		var item = null;
		var attributesChild = {}
		var xmlChild = null;
		for(var count = 0;count < this.__children.length;count++)
		{
			item = this.__children[count];
			if(item && !this.util.isUndefinedOrNull(item.width))
			{
				attributesChild = {"w:w": item.width};
				if(!this.util.isUndefinedOrNull(item.space))
				{
					attributesChild["w:space"] = item.space;
				}
				xmlChild = this.__exportUtil.getXML({
					name: "w:col",
					attributes: attributesChild,
				});
				arrChildren.push(xmlChild);
			}
		}
		var xml = null;
		if(Object.keys(attributes).length || arrChildren.length)
		{
			item = {name: "w:cols"};
			if(Object.keys(attributes).length)
			{
				item["attributes"] = attributes;
			}
			if(arrChildren.length)
			{
				item["children"] = arrChildren;
			}
			xml = this.__exportUtil.getXML(item);
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPsectionBorders.php
	var SectionBorder = function(docxRef)
	{
		//{val: null,sz: null,space: null,color: null}
		this.__objProp = {top: null,bottom: null,left: null,right: null};
		this.__objAttr = {display: null,offsetFrom: null,zOrder: null};
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,SectionBorder);
	SectionBorder.prototype.constructor = SectionBorder;
	NSDocxExport.prototype.SectionBorder = SectionBorder;
	
	SectionBorder.prototype.display = function(value)
	{
		return this.__setAttr("display",value);
	};
	
	SectionBorder.prototype.offsetFrom = function(value)
	{
		return this.__setAttr("offsetFrom",value);
	};
	
	SectionBorder.prototype.zOrder = function(value)
	{
		return this.__setAttr("zOrder",value);
	};
	
	SectionBorder.prototype.top = function(option)
	{
		return this.__setProp("top",option);
	};
	
	SectionBorder.prototype.bottom = function(option)
	{
		return this.__setProp("bottom",option);
	};
	
	SectionBorder.prototype.left = function(option)
	{
		return this.__setProp("left",option);
	};
	
	SectionBorder.prototype.right = function(option)
	{
		return this.__setProp("right",option);
	};
	
	SectionBorder.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	SectionBorder.prototype.__setProp = function(key,option)
	{
		option = option || {};
		if(!this.util.isUndefinedOrNull(option.value) || !this.util.isUndefinedOrNull(option.size) || !this.util.isUndefinedOrNull(option.space) || !this.util.isUndefinedOrNull(option.color))
		{
			var item = {val: option.value,sz: option.size,space: option.space,color: option.color};
			this.__objProp[key] = item;
		}
		return this.__objProp[key];
	};
	
	SectionBorder.prototype.__xmlProp = function(key,item)
	{
		var attributes = {};
		for(var paramKey in item)
		{
			if(!this.util.isUndefinedOrNull(item[paramKey]))
			{
				attributes["w:" + paramKey] = item[paramKey];
			}
		}
		var xml = this.__exportUtil.getXML({
			name: "w:" + key,
			attributes: attributes,
		});
		return xml;
	};
	
	SectionBorder.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this.__children.push(this.__xmlProp(key,item));
			}
		}
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:pgBorders",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPSectionPgMar.php
	var PageMargins = function(docxRef,header,bottom,top,right,left,footer,gutter)
	{
		this.__objAttr = {header: null,bottom: null,top: null,right: null,left: null,footer: null,gutter: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(header) && this.header(header);
		!this.util.isUndefinedOrNull(bottom) && this.bottom(bottom);
		!this.util.isUndefinedOrNull(top) && this.top(top);
		!this.util.isUndefinedOrNull(right) && this.right(right);
		!this.util.isUndefinedOrNull(left) && this.left(left);
		!this.util.isUndefinedOrNull(footer) && this.footer(footer);
		!this.util.isUndefinedOrNull(gutter) && this.gutter(gutter);
	};
	
	nsExtendPrototype(BaseElement,PageMargins);
	PageMargins.prototype.constructor = PageMargins;
	NSDocxExport.prototype.PageMargins = PageMargins;
	
	PageMargins.prototype.header = function(value)
	{
		return this.__setAttr("header",value);
	};
	
	PageMargins.prototype.bottom = function(value)
	{
		return this.__setAttr("bottom",value);
	};
	
	PageMargins.prototype.top = function(value)
	{
		return this.__setAttr("top",value);
	};
	
	PageMargins.prototype.right = function(value)
	{
		return this.__setAttr("right",value);
	};
	
	PageMargins.prototype.left = function(value)
	{
		return this.__setAttr("left",value);
	};
	
	PageMargins.prototype.footer = function(value)
	{
		return this.__setAttr("footer",value);
	};
	
	PageMargins.prototype.gutter = function(value)
	{
		return this.__setAttr("gutter",value);
	};
	
	PageMargins.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	PageMargins.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:pgMar",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsection.php (in Elements section)
	var PageSize = function(docxRef,height,width,orientation)
	{
		this.__objAttr = {h: null,w: null,orient: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(height) && this.height(height);
		!this.util.isUndefinedOrNull(width) && this.width(width);
		!this.util.isUndefinedOrNull(orientation) && this.orientation(orientation);
	};
	
	nsExtendPrototype(BaseElement,PageSize);
	PageSize.prototype.constructor = PageSize;
	NSDocxExport.prototype.PageSize = PageSize;
	
	PageSize.prototype.height = function(value)
	{
		return this.__setAttr("h",value);
	};
	
	PageSize.prototype.width = function(value)
	{
		return this.__setAttr("w",value);
	};
	
	PageSize.prototype.orientation = function(value)
	{
		return this.__setAttr("orient",value);
	};
	
	PageSize.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	PageSize.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:pgSz",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPSectionPgNumType.php
	var PageNumbers = function(docxRef,chapSep,chapStyle,fmt,start)
	{
		this.__objAttr = {chapSep: null,chapStyle: null,fmt: null,start: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(chapSep) && this.chapSep(chapSep);
		!this.util.isUndefinedOrNull(chapStyle) && this.chapStyle(chapStyle);
		!this.util.isUndefinedOrNull(fmt) && this.fmt(fmt);
		!this.util.isUndefinedOrNull(start) && this.start(start);
	};
	
	nsExtendPrototype(BaseElement,PageNumbers);
	PageNumbers.prototype.constructor = PageNumbers;
	NSDocxExport.prototype.PageNumbers = PageNumbers;
	
	PageNumbers.prototype.chapSep = function(value)
	{
		return this.__setAttr("chapSep",value);
	};
	
	PageNumbers.prototype.chapStyle = function(value)
	{
		return this.__setAttr("chapStyle",value);
	};
	
	PageNumbers.prototype.fmt = function(value)
	{
		return this.__setAttr("fmt",value);
	};
	
	PageNumbers.prototype.start = function(value)
	{
		return this.__setAttr("start",value);
	};
	
	PageNumbers.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	PageNumbers.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:pgNumType",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPsectionLineNumbering.php
	var LineNumbers = function(docxRef,countBy,distance,restart,start)
	{
		this.__objAttr = {countBy: null,distance: null,restart: null,start: null};
		this.base.init.call(this,docxRef);
		!this.util.isUndefinedOrNull(countBy) && this.countBy(countBy);
		!this.util.isUndefinedOrNull(distance) && this.distance(distance);
		!this.util.isUndefinedOrNull(restart) && this.restart(restart);
		!this.util.isUndefinedOrNull(start) && this.start(start);
	};
	
	nsExtendPrototype(BaseElement,LineNumbers);
	LineNumbers.prototype.constructor = LineNumbers;
	NSDocxExport.prototype.LineNumbers = LineNumbers;
	
	LineNumbers.prototype.countBy = function(value)
	{
		return this.__setAttr("countBy",value);
	};
	
	LineNumbers.prototype.distance = function(value)
	{
		return this.__setAttr("distance",value);
	};
	
	LineNumbers.prototype.restart = function(value)
	{
		return this.__setAttr("restart",value);
	};
	
	LineNumbers.prototype.start = function(value)
	{
		return this.__setAttr("start",value);
	};
	
	LineNumbers.prototype.__setAttr = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objAttr[key] = value;
		}
		return this.__objAttr[key];
	};
	
	LineNumbers.prototype.toXml = function()
	{
		var item = null;
		var key = null;
		var attributes = {};
		for(key in this.__objAttr)
		{
			item = this.__objAttr[key];
			if(!this.util.isUndefinedOrNull(item))
			{
				attributes["w:" + key] = item;
			}
		}
		if(attributes && Object.keys(attributes).length)
		{
			var xml = this.base.toXml.call(this,"w:lnNumType",attributes);
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPcontentOverview.php
	var Paragraph = function(docxRef,option)
	{
		this.__format = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Paragraph);
	Paragraph.prototype.constructor = Paragraph;
	NSDocxExport.prototype.Paragraph = Paragraph;
	
	Paragraph.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(option.text)
			{
				var run = this.addText(option.text);
			}
			if(option.pageBreak)
			{
				this.addPageBreak();
			}
			this.format(option);
		}
	};
	
	Paragraph.prototype.format = function(value)
	{
		if(value && value instanceof ParagraphFormat)
		{
			this.__format = value;
		}
		else
		{
			!this.__format && (this.__format = new ParagraphFormat(this.__docxRef,value));
		}
		return this.__format;
	};
	
	Paragraph.prototype.addRun = function(value)
	{
		var run = new Run(this.__docxRef,value);
	    this.__children.push(run);
	    return run;
	};
	
	Paragraph.prototype.addText = function(text)
	{
		var run = this.addRun();
		run.addText(text);
	    return run;
	};
	
	Paragraph.prototype.addCurrentPageNumber = function()
	{
		var format = this.format();
		if(!format.horizontalAlignment().value())
		{
			format.horizontalAlignment().value("center");
		}
		var run = this.__addSpecialString("PAGE");
		return run;
	};
	
	Paragraph.prototype.addTotalPageNumber = function()
	{
		var format = this.format();
		if(!format.horizontalAlignment().value())
		{
			format.horizontalAlignment().value("center");
		}
		var run = this.__addSpecialString("NUMPAGES");
		return run;
	};
	
	Paragraph.prototype.addTotalPageNumberInSection = function()
	{
		var format = this.format();
		if(!format.horizontalAlignment().value())
		{
			format.horizontalAlignment().value("center");
		}
		var run = this.__addSpecialString("SECTIONPAGES");
		return run;
	};
	
	Paragraph.prototype.addPageBreak = function()
	{
		var run = this.addRun();
		run.addBreak("page");
	    return run;
	};
	
	Paragraph.prototype.__addSpecialString = function(str)
	{
		var run = this.addRun();
		run.addFldChar("begin");
		run.addInstrText(str);
		run.addFldChar("separate");
		run.addFldChar("end");
		return run;
	};
	
	Paragraph.prototype.toXml = function()
	{
		//format should be at start
		if(this.__format)
		{
			this.__children.unshift(this.__format);
		}
		var xml = this.base.toXml.call(this,"w:p");
		return xml;
	};
	
	//http://officeopenxml.com/WPparagraphProperties.php
	//option value can have horizontalAlignment,borders,indentation,shading,spacing,tabs,verticalAlignment,keepNext,keepLines
	var ParagraphFormat = function(docxRef,option)
	{
		this.__objProp = {horizontalAlignment:{variable: "__hAlignment", method: "horizontalAlignment"},
						  borders:{variable: "__borders", method: "borders"},
						  indentation:{variable: "__indentation", method: "indentation"},
						  shading:{variable: "__shading", method: "shading"},
						  spacing:{variable: "__spacing", method: "spacing"},
						  contextualSpacing:{variable: "__contextualSpacing", method: "contextualSpacing",tag:"w:contextualSpacing",attr:"w:val"},
						  tabs:{variable: "__tabs", method: "tabs"},
						  verticalAlignment:{variable: "__vAlignment", method: "verticalAlignment"},
						  keepNext:{variable: "__keepNext", method: "keepNext", tag: "w:keepNext"},
						  keepLines:{variable: "__keepLines", method: "keepLines", tag: "w:keepLines"},
						  outlineLevel:{variable: "__outlineLevel", method: "outlineLevel",tag:"w:outlineLvl",attr:"w:val"},
						  styleID:{variable: "__styleID", method: "styleID",tag:"w:pStyle",attr:"w:val"},
						  numberingProperties:{variable: "__numberingProperties", method: "numberingProperties"}
						 };
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,ParagraphFormat);
	ParagraphFormat.prototype.constructor = ParagraphFormat;
	NSDocxExport.prototype.ParagraphFormat = ParagraphFormat;
	
	ParagraphFormat.prototype.setProperties = function(option)
	{
		if(option)
		{
			if (option.horizontalAlign) 
			{
                this.horizontalAlignment(option.horizontalAlign);
            }
			if(option.borders) 
            {
				this.borders(option.borders)
            }
			else if (option.horizontalLine) 
            {
                this.horizontalLine();
            }
            if (option.contextualSpacing) 
            {
                this.contextualSpacing(option.contextualSpacing);
            }
            if (option.rightTab) 
            {
            	var tabs = this.tabs();
            	tabs.addTab({val: "right",pos: option.rightTab});
            }
            if (option.leftTab) 
            {
            	var tabs = this.tabs();
            	tabs.addTab({val: "left",pos: option.leftTab});
            }
            if (option.indent) 
            {
                this.indentation(option.indent);
            }
            if (option.spacing) 
            {
                this.spacing(option.spacing);
            }
            if (option.keepNext) 
            {
                this.keepNext(true);
            }
            if (option.keepLines) 
            {
            	this.keepLines(true);
            }
            if (option.outlineLevel) 
            {
                this.outlineLevel(option.outlineLevel);
            }
            if (option.styleID) 
            {
                this.styleID(option.styleID);
            }
            if (option.numberingProperties) 
            {
            	this.numberingProperties(option.numberingProperties);
            }
		}
	};
	
	ParagraphFormat.prototype.horizontalAlignment = function(value)
	{
		if(value && value instanceof ParagraphHAlignment)
		{
			this.__hAlignment = value;
		}
		else
		{
			!this.__hAlignment && (this.__hAlignment = new ParagraphHAlignment(this.__docxRef,value));
		}
		return this.__hAlignment;
	};
	
	ParagraphFormat.prototype.horizontalLine = function()
	{
		var border = this.borders({bottom: {color: "auto",space: 1,value: "single",size: 6}});
	};
	
	ParagraphFormat.prototype.borders = function(value)
	{
		if(value && value instanceof ParagraphBorder)
		{
			this.__borders = value;
		}
		else
		{
			!this.__borders && (this.__borders = new ParagraphBorder(this.__docxRef,value));
		}
		return this.__borders;
	};
	
	ParagraphFormat.prototype.indentation = function(value)
	{
		if(value && value instanceof ParagraphIndentation)
		{
			this.__indentation = value;
		}
		else
		{
			!this.__indentation && (this.__indentation = new ParagraphIndentation(this.__docxRef,value));
		}
		return this.__indentation;
	};
	
	ParagraphFormat.prototype.shading = function(value)
	{
		if(value && value instanceof Shading)
		{
			this.__shading = value;
		}
		else
		{
			!this.__shading && (this.__shading = new Shading(this.__docxRef,value));
		}
		return this.__shading;
	};
	
	ParagraphFormat.prototype.spacing = function(value)
	{
		if(value && value instanceof ParagraphSpacing)
		{
			this.__spacing = value;
		}
		else
		{
			!this.__spacing && (this.__spacing = new ParagraphSpacing(this.__docxRef,value));
		}
		return this.__spacing;
	};
	
	ParagraphFormat.prototype.contextualSpacing = function(value)
	{
		this.__contextualSpacing = (value === false) ? 0 : 1;
		return this.__contextualSpacing;
	};
	
	ParagraphFormat.prototype.tabs = function(value)
	{
		if(value && value instanceof ParagraphTabs)
		{
			this.__tabs = value;
		}
		else
		{
			!this.__tabs && (this.__tabs = new ParagraphTabs(this.__docxRef));
		}
		return this.__tabs;
	};
	
	ParagraphFormat.prototype.verticalAlignment = function(value)
	{
		if(value && value instanceof ParagraphVAlignment)
		{
			this.__vAlignment = value;
		}
		else
		{
			this.__vAlignment = new ParagraphVAlignment(this.__docxRef);
		}
		return this.__vAlignment;
	};
	
	ParagraphFormat.prototype.keepNext = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__keepNext = value;
		}
		return this.__keepNext;
	};
	
	ParagraphFormat.prototype.keepLines = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__keepLines = value;
		}
		return this.__keepLines;
	};
	
	ParagraphFormat.prototype.outlineLevel = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__outlineLevel = value;
		}
		return this.__outlineLevel;
	};
	
	ParagraphFormat.prototype.styleID = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__styleID = value;
		}
		return this.__styleID;
	};
	
	ParagraphFormat.prototype.numberingProperties = function(value)
	{
		if(value && value instanceof NumberingProperties)
		{
			this.__numberingProperties = value;
		}
		else
		{
			!this.__numberingProperties && (this.__numberingProperties = new NumberingProperties(this.__docxRef,value));
		}
		return this.__numberingProperties;
	};
	
	ParagraphFormat.prototype.toXml = function()
	{
		var item = null;
		var attr = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(!this.util.isUndefinedOrNull(this[item.variable]))
			{
				if(item.tag && !item.attr && this[item.variable])
				{
					this.__children.push("<" + item.tag + "/>");  
				}
				else if(item.tag && item.attr)
				{
					attr = {};
					attr[item.attr] = this[item.variable];
					this.__children.push(this.__exportUtil.getXML({
						name: item.tag,
						attributes: attr,
					}));
				}
				else
				{
					this.__children.push(this[item.variable]);
				}
			}
		}
		var xml = this.base.toXml.call(this,"w:pPr");
		return xml;
	};
	
	var NumberingProperties = function(docxRef,option)
	{
		this.__objProp = {level: {value:null, method:"level",tag:"w:ilvl"},
						  numberID: {value:null, method:"numberID",tag:"w:numId"},
		};
		this.base.init.call(this,docxRef);
		this.__exportUtil.addSingleValueFunctions(this,this.__objProp,null,docxRef);
		this.setProperties(option);
		
	};
	
	nsExtendPrototype(BaseElement,NumberingProperties);
	NumberingProperties.prototype.constructor = NumberingProperties;
	NSDocxExport.prototype.NumberingProperties = NumberingProperties;
	
	NumberingProperties.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(!this.util.isUndefinedOrNull(option.level))
			{
				this.level(option.level);
			}
			if(!this.util.isUndefinedOrNull(option.numberID))
			{
				this.numberID(option.numberID);
			}
		}
	};
	
	NumberingProperties.prototype.toXml = function()
	{
		for(var key in this.__objProp)
		{
			var item = this.__objProp[key];
			if(!this.util.isUndefinedOrNull(item.value))
			{
				this.__children.push(this.__exportUtil.getValXml(item.value,item.tag));
			}
		}
		if(this.__children && this.__children.length > 0)
		{
			var xml = this.base.toXml.call(this,"w:numPr");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPalignment.php
	var ParagraphHAlignment = function(docxRef,value)
	{
		this.__value = null;
		this.base.init.call(this,docxRef);
		this.value(value);
	};
	
	nsExtendPrototype(BaseElement,ParagraphHAlignment);
	ParagraphHAlignment.prototype.constructor = ParagraphHAlignment;
	NSDocxExport.prototype.ParagraphHAlignment = ParagraphHAlignment;
	
	ParagraphHAlignment.prototype.value = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__value = value;
		}
		return this.__value;
	};
	
	ParagraphHAlignment.prototype.toXml = function()
	{
		if(!this.util.isUndefinedOrNull(this.__value))
		{
			var xml = this.__exportUtil.getXML({
				name: "w:jc",
				attributes: {"w:val": this.__value},
			});
			return xml;
		}
		return null;
	};

	//http://officeopenxml.com/WPborders.php
	var ParagraphBorder = function(docxRef,option)
	{
		//{val: null,sz: null,space: null,color: null}
		this.__objProp = {top: null,bottom: null,left: null,right: null};
		this.base.init.call(this,docxRef);
		if(option)
		{
			var item = null;
			for(var key in option)
			{
				if(this.__objProp.hasOwnProperty(key))
				{
					item = option[key];
					this[this.__objProp[key]](item);
				}
			}
		}
	};
	
	nsExtendPrototype(BaseElement,ParagraphBorder);
	ParagraphBorder.prototype.constructor = ParagraphBorder;
	NSDocxExport.prototype.ParagraphBorder = ParagraphBorder;
	
	//value,size,space,color
	ParagraphBorder.prototype.top = function(option)
	{
		return this.__setProp("top",option);
	};
	
	ParagraphBorder.prototype.bottom = function(option)
	{
		return this.__setProp("bottom",option);
	};
	
	ParagraphBorder.prototype.left = function(option)
	{
		return this.__setProp("left",option);
	};
	
	ParagraphBorder.prototype.right = function(option)
	{
		return this.__setProp("right",option);
	};
	
	ParagraphBorder.prototype.__setProp = function(key,option)
	{
		option = option || {};
		if(!this.util.isUndefinedOrNull(option.value) || !this.util.isUndefinedOrNull(option.size) || !this.util.isUndefinedOrNull(option.space) || !this.util.isUndefinedOrNull(option.color))
		{
			var item = {val: option.value,sz: option.size,space: option.space,color: option.color};
			this.__objProp[key] = item;
		}
		return this.__objProp[key];
	};
	
	ParagraphBorder.prototype.__xmlProp = function(key,item)
	{
		var attributes = {};
		for(var paramKey in item)
		{
			if(!this.util.isUndefinedOrNull(item[paramKey]))
			{
				attributes["w:" + paramKey] = item[paramKey];
			}
		}
		var xml = this.__exportUtil.getXML({
			name: "w:" + key,
			attributes: attributes,
		});
		return xml;
	};
	
	ParagraphBorder.prototype.toXml = function()
	{
		var item = null;
		for(var key in this.__objProp)
		{
			item = this.__objProp[key];
			if(item)
			{
				this.__children.push(this.__xmlProp(key,item));
			}
		}
		if(this.__children && this.__children.length)
		{
			var xml = this.base.toXml.call(this,"w:pBdr");
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPindentation.php
	var ParagraphIndentation = function(docxRef,option)
	{
		this.__objProp = {left: null,right: null,hanging: null,firstLine: null};
		this.base.init.call(this,docxRef);
		if(option)
		{
			!this.util.isUndefinedOrNull(option.left) && this.left(option.left);
			!this.util.isUndefinedOrNull(option.right) && this.right(option.right);
			!this.util.isUndefinedOrNull(option.hanging) && this.hanging(option.hanging);
			!this.util.isUndefinedOrNull(option.firstLine) && this.firstLine(option.firstLine);
		}
	};
	
	nsExtendPrototype(BaseElement,ParagraphIndentation);
	ParagraphIndentation.prototype.constructor = ParagraphIndentation;
	NSDocxExport.prototype.ParagraphIndentation = ParagraphIndentation;
	
	ParagraphIndentation.prototype.left = function(value)
	{
		return this.__setProp("left",value);
	};
	
	ParagraphIndentation.prototype.right = function(value)
	{
		return this.__setProp("right",value);
	};
	
	ParagraphIndentation.prototype.hanging = function(value)
	{
		return this.__setProp("hanging",value);
	};
	
	ParagraphIndentation.prototype.firstLine = function(value)
	{
		return this.__setProp("firstLine",value);
	};
	
	ParagraphIndentation.prototype.__setProp = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp[key] = value;
		}
		return this.__objProp[key];
	};
	
	ParagraphIndentation.prototype.toXml = function()
	{
		var attributes = {};
		for(var paramKey in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[paramKey]))
			{
				attributes["w:" + paramKey] = this.__objProp[paramKey];
			}
		}
		var xml = null;
		if(Object.keys(attributes).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:ind",
				attributes: attributes,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPshading.php
	var Shading = function(docxRef,option)
	{
		this.__objProp = {fill: null,color: null,val: null};
		this.base.init.call(this,docxRef);
		if(option)
		{
			!this.util.isUndefinedOrNull(option.fill) && this.fill(option.fill);
			!this.util.isUndefinedOrNull(option.color) && this.color(option.color);
			!this.util.isUndefinedOrNull(option.value) && this.val(option.value);
		}
	};
	
	nsExtendPrototype(BaseElement,Shading);
	Shading.prototype.constructor = Shading;
	NSDocxExport.prototype.Shading = Shading;
	
	Shading.prototype.fill = function(value)
	{
		return this.__setProp("fill",value);
	};
	
	Shading.prototype.color = function(value)
	{
		return this.__setProp("color",value);
	};
	
	Shading.prototype.val = function(value)
	{
		return this.__setProp("val",value);
	};
	
	Shading.prototype.__setProp = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp[key] = value;
		}
		return this.__objProp[key];
	};
	
	Shading.prototype.toXml = function()
	{
		var attributes = {};
		for(var paramKey in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[paramKey]))
			{
				attributes["w:" + paramKey] = this.__objProp[paramKey];
			}
		}
		var xml = null;
		if(Object.keys(attributes).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:shd",
				attributes: attributes,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPspacing.php
	var ParagraphSpacing = function(docxRef,option)
	{
		this.__objProp = {after: null,before: null,line: null,lineRule: null,beforeAutospacing: null,afterAutospacing: null};
		this.base.init.call(this,docxRef);
		if(option)
		{
			!this.util.isUndefinedOrNull(option.after) && this.after(option.after);
			!this.util.isUndefinedOrNull(option.before) && this.before(option.before);
			!this.util.isUndefinedOrNull(option.line) && this.line(option.line);
			!this.util.isUndefinedOrNull(option.lineRule) && this.lineRule(option.lineRule);
			!this.util.isUndefinedOrNull(option.beforeAutospacing) && this.beforeAutospacing(option.beforeAutospacing);
			!this.util.isUndefinedOrNull(option.afterAutospacing) && this.afterAutospacing(option.afterAutospacing);
		}
	};
	
	nsExtendPrototype(BaseElement,ParagraphSpacing);
	ParagraphSpacing.prototype.constructor = ParagraphSpacing;
	NSDocxExport.prototype.ParagraphSpacing = ParagraphSpacing;
	
	ParagraphSpacing.prototype.after = function(value)
	{
		return this.__setProp("after",value);
	};
	
	ParagraphSpacing.prototype.before = function(value)
	{
		return this.__setProp("before",value);
	};
	
	ParagraphSpacing.prototype.after = function(value)
	{
		return this.__setProp("after",value);
	};
	
	ParagraphSpacing.prototype.line = function(value)
	{
		return this.__setProp("line",value);
	};
	
	ParagraphSpacing.prototype.beforeAutospacing = function(value)
	{
		return this.__setProp("beforeAutospacing",value);
	};
	
	ParagraphSpacing.prototype.afterAutospacing = function(value)
	{
		return this.__setProp("afterAutospacing",value);
	};
	
	ParagraphSpacing.prototype.__setProp = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp[key] = value;
		}
		return this.__objProp[key];
	};
	
	ParagraphSpacing.prototype.toXml = function()
	{
		var attributes = {};
		for(var paramKey in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[paramKey]))
			{
				attributes["w:" + paramKey] = this.__objProp[paramKey];
			}
		}
		var xml = null;
		if(Object.keys(attributes).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:spacing",
				attributes: attributes,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPtab.php
	var ParagraphTabs = function(docxRef,option)
	{
		this.base.init.call(this,docxRef);
	};
	
	nsExtendPrototype(BaseElement,ParagraphTabs);
	ParagraphTabs.prototype.constructor = ParagraphTabs;
	NSDocxExport.prototype.ParagraphTabs = ParagraphTabs;
	
	ParagraphTabs.prototype.addTab = function(option)
	{
		if(option)
		{
			var tab = new ParagraphTab(this.__docxRef,option);
		    this.__children.push(tab);
		    return tab;
		}
		return null;
	};
	
	ParagraphTabs.prototype.toXml = function()
	{
		var xml = this.base.toXml.call(this,"w:tabs");
		return xml;
	};
	
	//http://officeopenxml.com/WPtab.php
	var ParagraphTab = function(docxRef,option)
	{
		this.__objProp = {leader: null,pos: null,val: null};
		this.base.init.call(this,docxRef);
		if(option)
		{
			!this.util.isUndefinedOrNull(option.leader) && this.leader(option.leader);
			!this.util.isUndefinedOrNull(option.pos) && this.pos(option.pos);
			!this.util.isUndefinedOrNull(option.val) && this.val(option.val);
		}
	};
	
	nsExtendPrototype(BaseElement,ParagraphTab);
	ParagraphTab.prototype.constructor = ParagraphTab;
	NSDocxExport.prototype.ParagraphTab = ParagraphTab;
	
	ParagraphTab.prototype.leader = function(value)
	{
		return this.__setProp("leader",value);
	};
	
	ParagraphTab.prototype.pos = function(value)
	{
		return this.__setProp("pos",value);
	};
	
	ParagraphTab.prototype.val = function(value)
	{
		return this.__setProp("val",value);
	};
	
	ParagraphTab.prototype.__setProp = function(key,value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__objProp[key] = value;
		}
		return this.__objProp[key];
	};
	
	ParagraphTab.prototype.toXml = function()
	{
		var attributes = {};
		for(var paramKey in this.__objProp)
		{
			if(!this.util.isUndefinedOrNull(this.__objProp[paramKey]))
			{
				attributes["w:" + paramKey] = this.__objProp[paramKey];
			}
		}
		var xml = null;
		if(Object.keys(attributes).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:tab",
				attributes: attributes,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPtextAlignment.php
	var ParagraphVAlignment = function(docxRef,value)
	{
		this.__value = null;
		this.base.init.call(this,docxRef);
		this.value(value);
	};
	
	nsExtendPrototype(BaseElement,ParagraphVAlignment);
	ParagraphVAlignment.prototype.constructor = ParagraphVAlignment;
	NSDocxExport.prototype.ParagraphVAlignment = ParagraphVAlignment;
	
	ParagraphVAlignment.prototype.value = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__value = value;
		}
		return this.__value;
	};
	
	ParagraphVAlignment.prototype.toXml = function()
	{
		if(!this.util.isUndefinedOrNull(this.__value))
		{
			var xml = this.__exportUtil.getXML({
				name: "w:textAlignment",
				attributes: {"w:val": this.__value},
			});
			return xml;
		}
		return null;
	};
	
	//http://officeopenxml.com/WPtext.php
	var Run = function(docxRef,option)
	{
		this.__format = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,Run);
	Run.prototype.constructor = Run;
	NSDocxExport.prototype.Run = Run;
	
	Run.prototype.setProperties = function(option)
	{
		if(option)
		{
			if(option.text)
			{
				var text = this.addText(option.text);
			}
			this.format(option);
		}
	};
	
	Run.prototype.format = function(value)
	{
		if(value && value instanceof RunFormat)
		{
			this.__format = value;
		}
		else
		{
			!this.__format && (this.__format = new RunFormat(this.__docxRef,value));
		}
		return this.__format;
	};
	
	Run.prototype.addText = function(str,spaceAttr)
	{
		var text = new Text(this.__docxRef,str,spaceAttr);
	    this.__children.push(text);
	    return text;
	};
	
	Run.prototype.addBreak = function(type,clear)
	{
		var runBreak = new RunBreak(this.__docxRef,type,clear);
	    this.__children.push(runBreak);
	    return runBreak;
	};
	
	Run.prototype.addInstrText = function(str,spaceType)
	{
		var instr = this.__exportUtil.getInstrText(str,spaceType);
		this.__children.push(instr);
		return instr;
	};
	
	Run.prototype.addFldChar = function(charType)
	{
		var fldChar = this.__exportUtil.getFldChar(charType);
		this.__children.push(fldChar);
		return fldChar;
	};
	
	Run.prototype.toXml = function()
	{
		//format should be at start
		if(this.__format)
		{
			this.__children.unshift(this.__format);
		}
		var xml = this.base.toXml.call(this,"w:r");
		return xml;
	};
	
	//http://officeopenxml.com/WPstyleCharStyles.php
	var RunFormat = function(docxRef,option)
	{
		this.__style = {bold:{value:false,tag: "w:b",attr:"w:val"},italic:{value:false,tag: "w:i",attr:"w:val"},color:{value:null,tag:"w:color",attr:"w:val"},
						underline:{value: null},size:{value:null,tag:"w:sz",attr:"w:val"},sizeCs:{value:null,tag:"w:szCs",attr:"w:val"},
						rightToLeft:{value:null,tag:"w:rtl",attr:"w:val"},smallCaps:{value:false,tag: "w:smallCaps"},caps:{value:false,tag: "w:caps"},
						strike:{value:false,tag:"w:strike",attr:"w:val"},doubleStrike:{value:false,tag:"w:dstrike",attr:"w:val"},
						subScript:{value:false,tag: "w:subscript"},superScript:{value:false,tag: "w:superscript"},
						styleID:{value:null,tag:"w:rStyle",attr:"w:val"},highlight:{value:null,tag:"w:highlight",attr:"w:val"},highlightCs:{value:null,tag:"w:highlightCs",attr:"w:val"},
						shadow:{value: null},shadowCs:{value: null},
						
					};
		this.__fonts = null;
		this.base.init.call(this,docxRef);
		this.setProperties(option);
	};
	
	nsExtendPrototype(BaseElement,RunFormat);
	RunFormat.prototype.constructor = RunFormat;
	NSDocxExport.prototype.RunFormat = RunFormat;
	
	RunFormat.prototype.setProperties = function(option)
	{
		if(option)
		{
			if (option.bold) 
			{
	            this.bold(true);
	        }
			if (option.italic) 
			{
				this.italic(true);
	        }
	        if (option.underline) 
	        {
	        	this.underline(option.underline.type, option.underline.color);
	        }
	        if (option.color) 
	        {
	        	this.color(option.color);
	        }
	        if (option.size) 
	        {
	            this.size(option.size);
	        }
	        if (option.rightToLeft) 
	        {
	        	this.rightToLeft(option.rightToLeft);
	        }
	        if (option.smallCaps) 
	        {
	        	this.smallCaps(option.smallCaps);
	        }
	        if (option.caps) 
	        {
	        	this.caps(option.caps);
	        }
	        if (option.strike) 
	        {
	        	this.strike(option.strike);
	        }
	        if (option.doubleStrike) 
	        {
	        	this.doubleStrike(option.doubleStrike);
	        }
	        if (option.subScript) 
	        {
	        	this.subScript(option.subScript);
	        }
	        if (option.superScript) 
	        {
	        	this.superScript(option.superScript);
	        }
	        if (option.highlight) 
	        {
	            this.highlight.push(option.highlight);
	        }
	        if (option.shadow) 
	        {
	            this.shadow(option.shadow.type,option.shadow.fill,option.shadow.color);
	        }
	        if (option.styleID) 
	        {
	        	this.styleID(option.styleID);
	        }
	        if (option.font) 
	        {
	            this.fonts(option.font);
	        }
		}
	};
	
	RunFormat.prototype.bold = function(value)
	{
		return this.__setStyle("bold",value);
	};
	
	RunFormat.prototype.italic = function(value)
	{
		return this.__setStyle("italic",value);
	};
	
	RunFormat.prototype.color = function(value)
	{
		return this.__setStyle("color",value);
	};
	
	RunFormat.prototype.underline = function(type,color)
	{
		type = type || "single";
		var attr = {"w:val": type};
		if(color)
		{
			attr["w:color"] = color;
		}
		var xml = this.__exportUtil.getXML({
			name: "w:u",
			attributes: attr
		});
		return this.__setStyle("underline",xml);
	};
	
	RunFormat.prototype.size = function(value)
	{
		this.__setStyle("sizeCs",value);
		return this.__setStyle("size",value);
	};
	
	RunFormat.prototype.rightToLeft = function(value)
	{
		return this.__setStyle("rightToLeft",value);
	};
	
	RunFormat.prototype.smallCaps = function(value)
	{
		return this.__setStyle("smallCaps",value);
	};
	
	RunFormat.prototype.caps = function(value)
	{
		return this.__setStyle("caps",value);
	};
	
	RunFormat.prototype.strike = function(value)
	{
		return this.__setStyle("strike",value);
	};
	
	RunFormat.prototype.doubleStrike = function(value)
	{
		return this.__setStyle("doubleStrike",value);
	};
	
	RunFormat.prototype.subScript = function(value)
	{
		return this.__setStyle("subScript",value);
	};
	
	RunFormat.prototype.superScript = function(value)
	{
		return this.__setStyle("superScript",value);
	};
	
	RunFormat.prototype.styleID = function(value)
	{
		return this.__setStyle("styleID",value);
	};
	
	RunFormat.prototype.highlight = function(value)
	{
		this.__setStyle("highlightCs",value);
		return this.__setStyle("highlight",value);
	};
	
	RunFormat.prototype.shadow = function(value, fill, color)
	{
		type = type || "single";
		var attr = {"w:val": value,"w:fill": fill,"w:color" : color};
		var xml = this.__exportUtil.getXML({
			name: "w:shdCs",
			attributes: attr
		});
		this.__setStyle("shadowCs",xml);
		xml = this.__exportUtil.getXML({
			name: "w:shd",
			attributes: attr
		});
		return this.__setStyle("shadow",xml);
	};
	
	RunFormat.prototype.fonts = function(value)
	{
		if(value && value instanceof RunFonts)
		{
			this.__fonts = value;
		}
		else
		{
			this.__fonts = new RunFonts(this.__docxRef,value);
		}
	    return this.__fonts;
	};
	
	RunFormat.prototype.__setStyle = function(key,value)
	{
		//key = key.toLowerCase();
		if(this.__style[key])
		{
			this.__style[key].value = value;
		}
		return this.__style[key].value;
	};
	
	RunFormat.prototype.toXml = function()
	{
		var item = null;
		var objItem = null;
		for(var key in this.__style)
		{
			item = this.__style[key];
			if(item.value)
			{
				if(item.tag)
				{
					objItem = {name: item.tag};
					if(item.attr)
					{
						objItem.attributes = {};
						objItem.attributes[item.attr] = item.value;
					}
					this.__children.push(this.__exportUtil.getXML(objItem));
				}
				else
				{
					this.__children.push(item.value);
				}
			}
		}
		if(this.__fonts)
		{
			var fontXml = this.__fonts.toXml();
			if(fontXml)
			{
				this.__children.push(fontXml);
			}
		}
		var xml = this.base.toXml.call(this,"w:rPr");
		return xml;
	};
	
	//http://officeopenxml.com/WPtextSpecialContent-break.php
	var RunBreak = function(docxRef,type,clear)
	{
		//value can be column,page,textWrapping 
		this.__type = null;
		//value can be all,left,none,right 
		this.__clear = null;
		this.base.init.call(this,docxRef);
		type && this.type(type);
		clear && this.clear(clear);
	};
	
	nsExtendPrototype(BaseElement,RunBreak);
	RunFormat.prototype.constructor = RunBreak;
	NSDocxExport.prototype.RunBreak = RunBreak;
	
	RunBreak.prototype.type = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__type = value;
		}
		return this.__type;
	};
	
	RunBreak.prototype.clear = function(value)
	{
		if(!this.util.isUndefinedOrNull(value))
		{
			this.__clear = value;
		}
		return this.__clear;
	};
	
	RunBreak.prototype.toXml = function()
	{
		var itemAttr = {};
		//default value
		!this.__type && (this.__type = "textWrapping");
		itemAttr["w:type"] = this.__type
		this.__clear && (itemAttr["w:clear"] = this.__clear);
		var xml = null;
		if(Object.keys(itemAttr).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:br",
				attributes: itemAttr,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPtextFonts.php
	var RunFonts = function(docxRef,option)
	{
		this.__prop = {ascii:{value:null,tag: "w:ascii"},cs:{value:null,tag: "w:cs"},eastasia:{value:null,tag:"w:eastAsia"},hansi:{value:null,tag:"w:hAnsi"},hint:{value:null,tag:"w:hint"}};
		this.base.init.call(this,docxRef);
		option = option || {};
		(option.ascii || option.name) && this.ascii(option.ascii || option.name);
		(option.cs || option.ascii || option.name) && this.cs(option.cs || option.ascii || option.name);
		(option.eastasia || option.ascii || option.name) && this.eastAsia(option.eastasia || option.ascii || option.name);
		(option.hansi || option.ascii || option.name) && this.hansi(option.hansi || option.ascii || option.name);
		option.hint && this.hint(option.hint);
	};
	
	nsExtendPrototype(BaseElement,RunFonts);
	RunFonts.prototype.constructor = RunFonts;
	NSDocxExport.prototype.RunFonts = RunFonts;
	
	RunFonts.prototype.ascii = function(value)
	{
		return this.__setProp("ascii",value);
	};
	
	RunFonts.prototype.cs = function(value)
	{
		return this.__setProp("cs",value);
	};
	
	RunFonts.prototype.eastAsia = function(value)
	{
		return this.__setProp("eastasia",value);
	};
	
	RunFonts.prototype.hansi = function(value)
	{
		return this.__setProp("hansi",value);
	};
	
	RunFonts.prototype.hint = function(value)
	{
		return this.__setProp("hint",value);
	};
	
	RunFonts.prototype.__setProp = function(key,value)
	{
		key = key.toLowerCase();
		if(this.__prop[key])
		{
			this.__prop[key].value = value;
		}
		return this.__prop[key].value;
	};
	
	RunFonts.prototype.toXml = function()
	{
		var item = null;
		var itemAttr = {};
		for(var key in this.__prop)
		{
			item = this.__prop[key];
			if(item.value)
			{
				itemAttr[item.tag] = item.value;
			}
		}
		var xml = null;
		if(Object.keys(itemAttr).length)
		{
			xml = this.__exportUtil.getXML({
				name: "w:rFonts",
				attributes: itemAttr,
			});
		}
		return xml;
	};
	
	//http://officeopenxml.com/WPtext.php
	var Text = function(docxRef,str,spaceAttr)
	{
		this.__str = null;
		this.__spaceAttr = null;
		this.base.init.call(this,docxRef);
		str && this.string(str);
		spaceAttr && this.spaceAttr(spaceAttr);
	};
	
	nsExtendPrototype(BaseElement,Text);
	Text.prototype.constructor = Text;
	NSDocxExport.prototype.Text = Text;
	
	Text.prototype.string = function(value)
	{
		if (!this.util.isUndefinedOrNull(value)) 
		{
			this.__str = value;
		}
		return this.__str;
	};
	
	Text.prototype.spaceAttr = function(value)
	{
		if (!this.util.isUndefinedOrNull(value)) 
		{
			this.__spaceAttr = value;
		}
		return this.__spaceAttr;
	};
	
	Text.prototype.toXml = function(value)
	{
		var xml = this.__exportUtil.getXML({
			name: "w:t",
			attributes: {"xml:space": this.__spaceAttr || "preserve"},
			children: [this.__str || ""]
		});
		return xml;
	};
	
	var ExportUtil = function(util)
	{
		this.util = util;
		this.xmlPrefix = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>\n';
		this.schemas = {
				'r': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships',
				'mx': 'http://schemas.microsoft.com/office/mac/excel/2008/main',
				'mc': 'http://schemas.openxmlformats.org/markup-compatibility/2006',
				'mv': 'urn:schemas-microsoft-com:mac:vml',
				'x14': 'http://schemas.microsoft.com/office/spreadsheetml/2009/9/main',
				'x14ac': 'http://schemas.microsoft.com/office/spreadsheetml/2009/9/ac',
				'xm': 'http://schemas.microsoft.com/office/excel/2006/main',
				'spreadsheetml': 'http://schemas.openxmlformats.org/spreadsheetml/2006/main',
				'relationshipPackage': 'http://schemas.openxmlformats.org/package/2006/relationships',
				'worksheet': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/worksheet',
				'stylesheet': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles',
				'sharedStrings': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/sharedStrings',
				'contentTypes': 'http://schemas.openxmlformats.org/package/2006/content-types',
				'officeDocument': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/officeDocument',
				'package': 'http://schemas.openxmlformats.org/package/2006/relationships',
				'table': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/table',
				'spreadsheetDrawing': 'http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing',
				'drawing': 'http://schemas.openxmlformats.org/drawingml/2006/main',
				'drawingRelationship': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/drawing',
				'image': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/image',
				'chart': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/chart',
				'hyperlink': 'http://schemas.openxmlformats.org/officeDocument/2006/relationships/hyperlink'
		};
		this.newLine = "\n";
		this.defaultFormat = true;
	};
		
	ExportUtil.prototype.getXML = function(config) 
	{
		var retValue = '<' + config.name;
		var content = '';
		var xmlPrefixAdded = false;
		if(config.addXmlPrefix)
		{
			retValue = this.xmlPrefix + retValue;
			xmlPrefixAdded = true;
		}
		if (config.ns) 
		{
			retValue = (xmlPrefixAdded ? "" : this.xmlPrefix) + retValue + ' xmlns="' + this.schemas[config.ns] + '"';
		}
		if (config.attributes) 
		{
			for(var key in config.attributes)
			{
				retValue += ' ' + key + '="' + this.escapeString(config.attributes[key]) + '"';
			}
		}
		if (!this.util.isUndefinedOrNull(config.value)) 
		{
			content += this.escapeString(config.value);
		}
		if (config.children) 
		{
			content += config.children.join('');
		}
		if (content) 
		{
			retValue += '>' + content + '</' + config.name + '>';
		} 
		else 
		{
			retValue += '/>';
		}
		if(this.util.isUndefinedOrNull(config.format))
		{
			config.format = this.defaultFormat;
		}
		return (config.format ? this.formatXml(retValue) : retValue);
		//return this.formatXml(retValue);
	};
	
	ExportUtil.prototype.escapeString = function(str)
	{
		return str;
	};
	
	ExportUtil.prototype.formatXml = function(xml,space)
	{
		var retValue = "";
		var indent= "";
		space = space || "\t";
		var arrXml = xml.split(/>\s*</);
		var tag = "";
		for(var count = 0;count < arrXml.length;count++)
		{
			tag = arrXml[count];
			//decrease space
			if(tag.match(/^\/\w/)) 
			{
				indent = indent.substring(space.length);
			}
			retValue += indent + "<" + tag + ">\r\n";
			//increase space
			if(tag.match(/^<?\w[^>]*[^\/]$/)) 
			{
				indent += space;
			}
		}
		retValue = retValue.substring(1, retValue.length - 3);
		return retValue;
	};
	
	ExportUtil.prototype.cloneObject = function(objSrc)
	{
		return JSON.parse(JSON.stringify(objSrc));
	};
	
	ExportUtil.prototype.getNonNullString = function(str)
	{
		return str = str || "";
	};
	
	ExportUtil.prototype.getInstrText = function(str,spaceType)
	{
		return "<w:instrText xml:space=\"" + (spaceType || "preserve") + "\">" + str + "</w:instrText>";
	};
	
	ExportUtil.prototype.getFldChar = function(charType)
	{
		return "<w:fldChar w:fldCharType=\"" + charType + "\"/>";
	};
	
	ExportUtil.prototype.addFunctions = function(instance,objItemsName,option,callback,docxRef)
	{
		var objProp = this.util.isString(objItemsName) ? instance[objItemsName] : objItemsName;
		if(objProp && Object.keys(objProp).length)
		{
			var defaultCallback = function(value,paramItem,key,paramInstance)
			{
				if(value && value instanceof NSDocxExport.prototype[paramItem.className])
				{
					paramItem.value = value;
				}
				else
				{
					!paramItem.value && (paramItem.value = new NSDocxExport.prototype[paramItem.className](docxRef,value));
				}
				return paramItem.value;
			};
			callback = callback || defaultCallback;
			var item = objProp[Object.keys(objProp)[0]];
			if(!instance[item.method])
			{
				option = option || {};
				for(var key in objProp)
				{
					item = objProp[key];
					(function(item,key)
					{
						if(!instance[item.method])
						{
							instance[item.method] = function(value)
							{
								return callback(value,item,key,instance);
							};
						}
						if(option[key])
						{
							instance[item.method](option[key]);
						}
					})(item,key)
				}
			}
		}
	};
	
	ExportUtil.prototype.addSingleValueFunctions = function(instance,objItemsName,option,docxRef)
	{
		var callback = function(value,paramItem,key,paramInstance)
		{
			if(!paramInstance.util.isUndefinedOrNull(value))
			{
				paramItem.value = value;
			}
			return paramItem.value;
		};
		this.addFunctions(instance,objItemsName,option,callback,docxRef);
	};
	
	ExportUtil.prototype.getValXml = function(value,xmlTag)
	{
		var xml = null;
		if(!this.util.isUndefinedOrNull(value))
		{
			xml = this.getXML({
				name: xmlTag,
				attributes: {"w:val": value},
			});
		}
		return xml;
	};
	
	return NSDocxExport;
})();
nsModuleExport(this,"NSDocxExport",NSDocxExport);