import * as React from 'react';
import '../../generated/css/nsComponent.min.css';
import '../../generated/css/nsMessageBox.min.css';
import NSBaseReactComponent from '../base/nsBaseReactComponent';
import { INSMessageBoxCallbackFunction, INSMessageBoxSetting, INSMessageBoxAlertSetting, INSMessageBoxConfirmSetting, INSMessageBoxCustomSetting } from "./interfaces";
export interface INSMessageBoxReactSettings extends INSMessageBoxSetting {
    setting?: INSMessageBoxSetting;
    containerStyle?: any;
    [propName: string]: any;
}
export declare class NSMessageBoxReact extends NSBaseReactComponent<INSMessageBoxReactSettings, any> {
    props: INSMessageBoxReactSettings;
    state: any;
    private __objNSMessageBox;
    private __objNSPanel;
    private __container;
    private __objBodyContent;
    private __setting;
    private __nsUtil;
    private __arrEvents;
    private __objCustomComponent;
    private __bodyComponentInstance;
    private __hasInitialized;
    private __hasDestroyed;
    private portals;
    private hasPendingPortalUpdate;
    private updateCallbacksOnUpdate;
    constructor(props: INSMessageBoxReactSettings, state: any);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentWillUnmount(): void;
    render(): React.JSX.Element;
    getElement(): HTMLElement;
    minimize(): void;
    maximize(): void;
    collapse(): void;
    expand(): void;
    fullScreen(): void;
    restore(): void;
    disableResize(): void;
    disableDrag(): void;
    disableCollapse(): void;
    disableMinMax(): void;
    disableFullScreen(): void;
    isCollapsed(): boolean;
    isMinimized(): boolean;
    isFullScreen(): boolean;
    alert(message: string | INSMessageBoxAlertSetting, title?: string, callback?: INSMessageBoxCallbackFunction): void;
    confirm(message: string | INSMessageBoxConfirmSetting, title?: string, confirmCallback?: INSMessageBoxCallbackFunction, cancelCallback?: INSMessageBoxCallbackFunction): void;
    custom(setting: INSMessageBoxCustomSetting): void;
    close(): void;
    removeModal(): void;
    changeButtonStyle(btnIdentifier: any, objStyle: any): void;
    getPanel(): any;
    getBodyComponentInstance(): any;
    private batchUpdateCallback;
    private __createComponent;
    private __creationHandler;
    private __customEditor;
    private __getComponent;
    private __getStyleForContainer;
    private __addEvents;
    private __eventListener;
    private __emitRendererComponentCreated;
}
