import React from 'react';
import NSBaseReactComponent from '../base/nsBaseReactComponent';
import '../../generated/css/nsComponent.min.css';
import '../../generated/css/nsNavigation.min.css';
import { INSNavigationMenu, INSNavigationSetting } from "./interfaces";
export interface INSNavigationReactSettings extends INSNavigationSetting {
    setting?: INSNavigationSetting;
    containerStyle?: any;
    [propName: string]: any;
}
export declare class NSNavigationReact extends NSBaseReactComponent<INSNavigationReactSettings, any> {
    props: INSNavigationReactSettings;
    state: any;
    static contextTypes: React.ValidationMap<any>;
    private __nsNavigation;
    private __container;
    private __nsUtil;
    private __arrEvents;
    private __dataSource;
    private __setting;
    private __hasInitialized;
    private __hasDataSource;
    private __hasDestroyed;
    constructor(props: INSNavigationReactSettings, state: any);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    processProps(nextProps: any): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<any, string | React.JSXElementConstructor<any>>;
    getElement(): any;
    private __addMethods;
    private __addMethod;
    isNavOpen(): boolean;
    toggleNavigation(): void;
    openNavigation(): void;
    closeNavigation(): void;
    getItemByField(field: string, value: any, source?: null): any;
    selectMenu(itemOrElement: any): void;
    setDataSource(source: INSNavigationMenu[]): void;
    setStyle(styleProp: string, value: any): void;
    setFocus(isFocus: boolean): void;
    hasFocus(): boolean;
    setTheme(theme: string): void;
    private __manageDataSource;
    private __manageDataSourceItem;
    private __menuClickHandler;
    private __getStyleForContainer;
    private __addEvents;
    private __eventListener;
}
